(**************************************************)
(*       *)
(*           *)
(**************************************************)

{$A+,B-,F-,I-,N-,O-,Q-,R-,S-}

unit F_Mouse;

	INTERFACE

type
  { 騩 ⨯ ᯮ  ।
    ⮢, 롨ࠥ  }
  MouseItemType = record
    x1, y1, x2, y2 : Integer;	{ न  }
    Butt,			{ ᫮ 맮 }
    Key : Word			{ -  }
  end;
  {  MouseHandlerType । 楤
    ࠡ⪨ ᮡ⨩   }
  MouseHandlerType =
    procedure(Mask, Buttons, x, y, dx, dy : Integer);

const
{ 롮   }
  LeftButton	= 1;
  RightButton	= 2;
  CenterButton	= 4;
  AnyButton	= 7;
{ 樥 ॢ 㠫 न  ⥪⮢.
   樥 ᫥ , ᫨  ᯮ 
  ᪮ ० , ⫨  8x8.  ⮬ 
  TextRatioX ᫥  ਭ ᨬ  ᥫ,
    TextRatioY -  }
  TextRatioX	: Byte = 8;
  TextRatioY	: Byte = 8;

{ -----------------  : ------------------- }

function IsMouse : Boolean;
{ 頥 true, ᫨  㯭 }

function InitMouse : Boolean; { 樠  }

procedure SetMousePage(Page : Byte);
{ ⠭ ࠭  㪠⥫  }

function GetMousePage : Byte;
{ 頥  ࠭  㪠⥫ }

procedure SetStepToPixel(Hor, Ver : Integer);
{ ⠭ ⢨⥫쭮  }

procedure GetStepToPixel(var Hor, Ver : Integer);
{ 頥 ⢨⥫쭮  }

procedure SetDoubleSpeed(Speed : Word);
{ ⠭ ண 㤢 ᪮ }

function GetDoubleSpeed : Word;
{ 頥 ண 㤢 ᪮ }

{ ---------------------- : ---------------------- }

function MouseTextCooX(x : Integer) : Byte;
{ 頥 ⥪⮢ न X  㠫쭮 }

function MouseTextCooY(y : Integer) : Byte;
{ 頥 ⥪⮢ न Y  㠫쭮 }

function MouseGraphCooX(x : Byte) : Integer;
{ 頥 㠫 न X  ⥪⮢ }

function MouseGraphCooY(y : Byte) : Integer;
{ 頥 㠫 न Y  ⥪⮢ }

procedure MouseWhereXY(var x, y : Integer);
{ 頥 㠫 न }

procedure MouseGoToXY(x, y : Integer);
{ ⠭ 㪠⥫    
	x, y - 㠫 न }

function MouseWhereX : Byte;
{ 頥 ⥪⮢ न X }

function MouseWhereY : Byte;
{ 頥 ⥪⮢ न Y }

function MouseIn(x1, y1, x2, y2 : Integer) : Boolean;
{ 頥 true, ᫨ 㪠⥫ 室  
  אַ㣮쭨; न - 㠫 }

{ ------------------  : -------------------- }

function NumButton : Byte;
{ 頥 ⢮   }

procedure GetMouseState(var Butt, x, y : Integer);
{ 頥 ⥪饥 ﭨ 
	Butt -  ﭨ 
	x, y - 騥 㠫 न }

function MousePressed : Boolean;
{ 頥 true, ᫨    }

procedure MouseButtPressed(Butt : Integer;
  var Stat, Count, x, y : Integer);
{ 頥 ଠ  ⮩ 
	Butt -  롮 
	Stat - ﭨ 
	Count - ⢮ ⨩
	x, y - न }

procedure MouseButtReleased(Butt : Integer;
  var Stat, Count, x, y : Integer);
{ 頥 ଠ  饭 
	Butt -  롮 
	Stat - ﭨ 
	Count - ⢮ ᪠
	x, y - न }

{ -------------------------- : ------------------------ }

procedure MouseWindow(x1, y1, x2, y2 : Integer);
{  न  ६饭 㪠⥫
	x1, y1, x2, y2 - 㠫 न }

procedure MouseScreen; { ⠭    ࠭ }

{ ------------------  : --------------------- }

procedure ShowMouse; {  㪠⥫  }

procedure HideMouse; {  㪠⥫  }

procedure MouseTextCursor(ScrMask, CurMask : Word);
{ ⠭   ⥪⮢ 㪠⥫ }

procedure MouseBlink(YUp, YDn : Byte);
{    㦭 ࠧ }

procedure MouseGraphCursor(var ScrCurMask; x, y : Byte);
{   ᪮ 㪠⥫ }

{ --------- / : ---------- }

function MouseBuffSize : Word;
{ 頥    ࠭ ࠬ஢ }

procedure SaveMouse(var Buff);
{ ࠭   ⥪饥 ﭨ  }

procedure RestoreMouse(var Buff);
{ ⠭ ࠭ ﭨ }

{ ----------------  : ------------------- }

procedure SetMouseItem(NItem : Byte; var Items);
{ ⠭   롮 
	NItem - ⢮ ⮢
	Items = array [1..NItem] of MouseItemType
   ⠭ 뢠 }

procedure AddMouseItem(Item : MouseItemType);
{      롮 ,
   ⠭ ࠭ }

procedure ClearMouseItems;
{ 뢠 ࠭ ⠭  }

procedure GetMouseItem(var NItem : Byte; var Items);
{ 頥 ⠭  }

function KeyOrMousePressed : Boolean;
{ 頥 true, ᫨    ⨢  }

function ReadKeyOrMouse : Char;
{ 頥 ᨬ ⮩   ࠭  }

{ ------------    : ----------------- }

procedure SetMouseHandler(Mask : Word;
  Proc : MouseHandlerType);
{ ⠭   ᫮ 맮 ࠡ稪 }

procedure ChangeMouseHandler(Mask : Word;
  Proc : MouseHandlerType; var OldMask : Word;
    var OldProc : Pointer);
{   ࠡ稪  }

procedure ClearMouseHandler; {  ࠡ稪 ᮡ⨩ }

	IMPLEMENTATION

uses Dos, Crt;

type
  MouseItems = array [1..2*MaxInt div SizeOf(MouseItemType)]
    of MouseItemType;
  PMouseIt = ^MouseItems;

const
  MousePresent	: Boolean = false; { ਧ   }
  ItemsList	: PMouseIt = nil; { ᨢ ⮢ 롮 }
  NMouseItem	: Byte = 0; { ⢮ ⮢ 롮 }
  MouseVisible	: Boolean = false; { ਧ  㪠. }
  x1m		: Integer = 0;	{ न  }
  y1m		: Integer = 0;	{ ६饭 㪠⥫ }
  x2m		: Integer = 639;
  y2m		: Integer = 199;
  Speed2	: Word = 128;	{ ண 㤢 ᪮ }
  VerRat	: Integer = 8;	{ ⢨⥫쭮  }
  HorRat	: Integer = 8;
  NButton	: Byte = 0;	{ ⢮   }

var reg : Registers;

function IsMouse : Boolean;
var
  p : Pointer;
  Is : Boolean;
begin
  if NButton=0 then
  begin
    GetIntVec($33,p); Is:=p<>nil;
    if Is then with reg do
    begin
      ax:=3; bx:=$ffff; Intr($33,reg); Is:=bx<>$ffff
    end;
    MousePresent:=Is
  end;
  IsMouse:=MousePresent
end;

function InitMouse : Boolean;
begin
  with reg do
  begin
    ax:=0; Intr($33,reg); MousePresent:=ax=$ffff; NButton:=bx
  end;
  ClearMouseItems; SetMousePage(0); HideMouse; MouseScreen
end;

procedure SetMousePage(Page : Byte);
begin
  with reg do
  begin
    ax:=$1d; bl:=Page; bh:=0; Intr($33,reg)
  end
end;

function GetMousePage : Byte;
begin
  with reg do
  begin
    ax:=$1e; Intr($33,reg); GetMousePage:=bl
  end
end;

procedure SetStepToPixel(Hor, Ver : Integer);
begin
  if IsMouse then with reg do
  begin
    ax:=$0f; cx:=Hor and $7fff; dx:=Ver and $7fff;
    HorRat:=cx; VerRat:=dx; Intr($33,reg)
  end
end;

procedure GetStepToPixel(var Hor, Ver : Integer);
begin
  if IsMouse then
  begin
    Hor:=HorRat; Ver:=VerRat
  end
end;

procedure SetDoubleSpeed(Speed : Word);
begin
  if IsMouse then with reg do
  begin
    ax:=$13; dx:=Speed; Speed2:=Speed; Intr($33,reg)
  end
end;

function GetDoubleSpeed : Word;
begin
  GetDoubleSpeed:=Speed2
end;

function MouseTextCooX(x : Integer) : Byte;
begin
  MouseTextCooX:=x div TextRatioX + 1
end;

function MouseTextCooY(y : Integer) : Byte;
begin
  MouseTextCooY:=y div TextRatioY + 1
end;

function MouseGraphCooX(x : Byte) : Integer;
begin
  MouseGraphCooX:=(x-1)*TextRatioX
end;

function MouseGraphCooY(y : Byte) : Integer;
begin
  MouseGraphCooY:=(y-1)*TextRatioY
end;

procedure MouseWhereXY(var x, y : Integer);
begin
  if IsMouse then with reg do
  begin
    ax:=3; Intr($33,reg); x:=cx; y:=dx
  end
  else begin
    x:=-1; y:=-1
  end
end;

procedure MouseGoToXY(x, y : Integer);
begin
  if IsMouse then with reg do
  begin
    ax:=4; cx:=x; dx:=y; Intr($33,reg)
  end
end;

function MouseWhereX : Byte;
begin
  if IsMouse then with reg do
  begin
    ax:=3; Intr($33,reg); MouseWhereX:=MouseTextCooX(cx)
  end
  else MouseWhereX:=0
end;

function MouseWhereY : Byte;
begin
  if IsMouse then with reg do
  begin
    ax:=3; Intr($33,reg); MouseWhereY:=MouseTextCooY(dx)
  end
  else MouseWhereY:=0
end;

function MouseIn(x1, y1, x2, y2 : Integer) : Boolean;
begin
  if IsMouse then with reg do
  begin
    ax:=3; Intr($33,reg);
    MouseIn:=(cx>=x1) and (cx<=x2) and (dx>=y1) and (dx<=y2)
  end
  else MouseIn:=false
end;

function NumButton : Byte;
begin
  NumButton:=NButton
end;

procedure GetMouseState(var Butt, x, y : Integer);
begin
  if IsMouse then with reg do
  begin
    ax:=3; Intr($33,reg); Butt:=bx; x:=cx; y:=dx
  end
  else begin
    Butt:=0; x:=0; y:=0
  end
end;

function MousePressed : Boolean;
begin
  if IsMouse then with reg do
  begin
    ax:=3; Intr($33,reg); MousePressed:=bx<>0
  end
  else MousePressed:=false
end;

procedure MouseButtPressed(Butt : Integer;
  var Stat, Count, x, y : Integer);
begin
  if IsMouse then with reg do
  begin
    ax:=5; bx:=Butt; Intr($33,reg);
    Count:=bx; x:=cx; y:=dx; Stat:=bx
  end
  else
end;

procedure MouseButtReleased(Butt : Integer;
  var Stat, Count, x, y : Integer);
begin
  if IsMouse then with reg do
  begin
    ax:=6; bx:=Butt; Intr($33,reg);
    Count:=bx; x:=cx; y:=dx; Stat:=bx
  end
  else
end;

procedure MouseWindow(x1, y1, x2, y2 : Integer);
begin
  if IsMouse then
  begin
    x1m:=x1; y1m:=y1; x2m:=x2; y2m:=y2;
    with reg do
    begin
      ax:=7; cx:=x1; dx:=x2; Intr($33,reg);
      ax:=8; cx:=y1; dx:=y2; Intr($33,reg)
    end
  end
end;

procedure MouseScreen;
var x2, y2 : Integer;
begin
  if IsMouse then with reg do
  begin
    ah:=$f; Intr($10,reg);
    case al of
      1,4,5,13: begin x2:=319; y2:=199 end;
      15,16: begin x2:=639; y2:=349 end;
      17,18: begin x2:=639; y2:=479 end
      else x2:=639; y2:=199
    end
  end;
  MouseWindow(0,0,x2,y2)
end;

procedure ShowMouse;
begin
  if IsMouse and not MouseVisible then with reg do
  begin
    ax:=1; Intr($33,reg); MouseVisible:=true
  end
end;

procedure HideMouse;
begin
  if IsMouse and MouseVisible then with reg do
  begin
    ax:=2; Intr($33,reg); MouseVisible:=false
  end
end;

procedure MouseTextCursor(ScrMask, CurMask : Word);
begin
  if IsMouse then with reg do
  begin
    ax:=$a; bx:=0; cx:=ScrMask; dx:=CurMask; Intr($33,reg)
  end
end;

procedure MouseBlink(YUp, YDn : Byte);
begin
  if IsMouse then with reg do
  begin
    ax:=$a; bx:=1; cx:=YUp; dx:=YDn; Intr($33,reg)
  end
end;

procedure MouseGraphCursor(var ScrCurMask; x, y : Byte);
begin
  if IsMouse then with reg do
  begin
    ax:=$9; bx:=x; cx:=y; es:=Seg(ScrCurMask);
    dx:=Ofs(ScrCurMask); Intr($33,reg)
  end
end;

function MouseBuffSize : Word;
begin
  if IsMouse then with reg do
  begin
    ax:=$15; bx:=0; Intr($33,reg); MouseBuffSize:=bx
  end
  else MouseBuffSize:=0
end;

procedure SaveMouse(var Buff);
begin
  if IsMouse then with reg do
  begin
    ax:=$16; es:=Seg(Buff); dx:=Ofs(Buff); Intr($33,reg)
  end
end;

procedure RestoreMouse(var Buff);
begin
  if IsMouse then with reg do
  begin
    ax:=$17; es:=Seg(Buff); dx:=Ofs(Buff); Intr($33,reg)
  end
end;

const DoubleChars : Boolean = false;
var SecChar : Char;

procedure SetMouseItem(NItem : Byte; var Items);
begin
  if IsMouse then
  begin
    ClearMouseItems;
    GetMem(ItemsList,NItem*SizeOf(MouseItemType));
    Move(Items,ItemsList^,NItem*SizeOf(MouseItemType));
    NMouseItem:=NItem
  end
end;

procedure AddMouseItem(Item : MouseItemType);
var
  k : Byte;
  p : PMouseIt;
begin
  if IsMouse then
  begin
    k:=NMouseItem; GetMem(p,(k+1)*SizeOf(MouseItemType));
    Move(ItemsList^,p^,k*SizeOf(MouseItemType));
    Move(Item,p^[k+1],SizeOf(MouseItemType));
    ClearMouseItems; NMouseItem:=k+1; ItemsList:=p
  end
end;

procedure ClearMouseItems;
begin
  if IsMouse and (NMouseItem<>0) then
  begin
    FreeMem(ItemsList,NMouseItem*SizeOf(MouseItemType));
    NMouseItem:=0
  end
end;

procedure GetMouseItem(var NItem : Byte; var Items);
begin
  if IsMouse and (NMouseItem<>0) then
  begin
    NItem:=NMouseItem;
    Move(ItemsList^,Items,NMouseItem*SizeOf(MouseItemType))
  end
end;

function KeyOrMousePressed : Boolean;
var
  b, k : Integer;
  MouseActive : Boolean;
begin
  { 砫 ஢塞  }
  if KeyPressed then KeyOrMousePressed:=true else
  { ᫨    ,
    ஢塞 ⨥   }
  with reg do begin
    ax:=3; Intr($33,reg);
    if (bx<>0) and (NMouseItem<>0) then
    begin
      { ,  . ࣠㥬 横
	஢ન  ᥬ ⠬ }
      MouseActive:=false;
      for k:=1 to NMouseItem do
	if not MouseActive then with ItemsList^[k] do
      begin
	case Butt of
	  LeftButton: b:=bx and LeftButton;
	  RightButton: b:=bx and RightButton;
	  CenterButton: b:=bx and CenterButton;
	  AnyButton: b:=bx else b:=0
	end;
	MouseActive:=(b<>0) and
	  MouseIn(MouseGraphCooX(x1),MouseGraphCooY(y1),
	    MouseGraphCooX(x2),MouseGraphCooY(y2))
      end;
      KeyOrMousePressed:=MouseActive
    end
    { ᫨  ⨢   
      ࠭ , 頥 false }
    else KeyOrMousePressed:=false
  end
end;

function ReadKeyOrMouse : Char;
var
  k : Byte;
  b, bb : Word;
  MouseActive : Boolean;
label loop;
begin
  { 砫 ஢塞 ⨥  }
  loop: if not IsMouse or KeyPressed then
    ReadKeyOrMouse:=ReadKey
    {  ஢ਬ  㦥  }
    else if DoubleChars then
  begin
    DoubleChars:=false; ReadKeyOrMouse:=SecChar
  end
  { ஢塞 室 ஫
    ⮢ ࠭  樨  }
  else if NMouseItem<>0 then with reg do
  begin
    { , 㦭 ஢ઠ }
    MouseActive:=false;
    { ஫㥬 롮    ⮢ }
    { 砥   } ax:=3; Intr($33,reg);
    {    bb } bb:=bx;
    if bb<>0 then
    { ᫨   ,  ࣠㥬 ஢
       ⮢  㦭 (ActiveMouse ⠭ true) }
    for k:=1 to NMouseItem do
      if not MouseActive then with ItemsList^[k] do
    begin
      case Butt of
	LeftButton: b:=bb and LeftButton;
	RightButton: b:=bb and RightButton;
	CenterButton: b:=bb and CenterButton;
	AnyButton: b:=bb else b:=0
      end;
      if (b<>0) and MouseIn(
	MouseGraphCooX(x1),MouseGraphCooY(y1),
	  MouseGraphCooX(x2),MouseGraphCooY(y2)) then
      begin
	{  ⬥祭  }
	MouseActive:=true; ReadKeyOrMouse:=Char(Lo(Key));
	if Lo(Key)=0 then
	begin
	  {  㦥  }
	  DoubleChars:=true; SecChar:=Chr(Hi(Key))
	end
      end
    end;
    { ᫨   ⬥⨫ , 塞  砫 }
    if not MouseActive then goto loop
  end
  { ᫨  ⠭     ,
        }
  else ReadKeyOrMouse:=ReadKey
end;

const OldUserProc : Pointer = nil;
var
  OldAX : Word;
  UserProc : MouseHandlerType absolute OldUserProc;

procedure MouseHandler; far; assembler;
asm
{ ࠭塞  ⥪ ॣ }
	push	bp
	push	ds
	push	es
	push	ax
	mov	ax, Seg @data
	mov	ds, ax
	pop	ax
	mov	OldAX, ax
{ ஢塞 ᫮ 맮 }
	mov	ax, Word ptr [OldUserProc] {   }
	or	ax, Word ptr [OldUserProc+2] { =nil ? }
	jz	@			{  -  뢠 }
{ ⮢ 맮 楤 짮⥫ }
	mov	ax, OldAX
	push	ax		{ Mask:=ax }
	push	bx		{ Buttons:=bx }
	push	cx		{ x:=cx }
	push	dx		{ y:=dx }
	push	di		{ dx:=di }
	push	si		{ dy:=si }
{ 뢠 楤 짮⥫ }
	call	[UserProc]
{ 室  楤: ⠭ ॣ }
@:	pop	es
	pop	ds
	pop	bp
	ret	far
end;

procedure SetMouseHandler(Mask : Word;
  Proc : MouseHandlerType);
begin
  if IsMouse then with reg do
  begin
    UserProc:=Proc; ax:=$c; cx:=Mask; es:=Seg(MouseHandler);
    dx:=Ofs(MouseHandler); Intr($33,reg)
  end
end;

procedure ChangeMouseHandler(Mask : Word;
  Proc : MouseHandlerType; var OldMask : Word;
    var OldProc : Pointer);
begin
  if IsMouse then with reg do
  begin
    OldProc:=OldUserProc; ax:=$14; cx:=Mask;
    es:=Seg(MouseHandler); dx:=Ofs(MouseHandler);
    Intr($33,reg); OldMask:=cx
  end
end;

procedure ClearMouseHandler;
begin
  if IsMouse then with reg do
  begin
    ax:=$c; cx:=0; dx:=0; es:=0; Intr($33,reg)
  end
end;

end { F_Mouse }.