program Edit_CHR;
{   ⮢ ଠ CHR }

uses Crt, Graph, F_GrText, F_Mouse;

type
  TChar4 = array [1..4] of Char;
  {    }
  TFontHead = record case Byte of
    0: (FontFileID: TChar4);
    1: (B : array [1..128] of Byte)
  end;
  {  ࠬ஢  }
  TFontPara = record case Byte of
    0: (ParPrefix : Char;	{  '+' }
	CharsCount : Word;	{ ᫮ ᨬ   }
	Reserv1,		{  ᯮ }
	FirstChar : Byte;	{  ࢮ ᨬ }
	DataOffset : Word;	{ 饭  
				   ࢮ ᨬ }
	FillFlag,		{   }
	UpperMargin,		{  ᨬ }
	Reserv2 : Byte;		{  ᯮ }
	LowerMargin : ShortInt;	{  ஬ }
	Reserv3 : array [1..5] of Byte); {  ᯮ }
    1: (H2 : array [1..16] of Byte)
  end;
  TOffst = array [0..255] of Word;	{ 饭 }
  TWidth = array [0..255] of Byte;	{ ਭ }
  TChars = array [0..255] of Pointer;	{  }
  TLengD = array [0..255] of Word;	{  }
  AW = array [1..255] of Word;
  {  ࠡ祣  }
  TCooE = record
    x1, y1, x2, y2 : Integer
  end;
  TMouseMask = array [0..1, 0..15] of Word;

var
  FontHead : TFontHead; {  䠩 }
  FontPara : TFontPara; { ࠬ  }
  NVecE,		{ ⢮ ஢  WE }
  FileSize,		{  㦠  䠩 }
  HeaderSize : Word;	{ 饭  ࠬ஢ }
  FName : string;	{  䠩 }
  F : file;		{ CHR-䠩 }
  Widths : TWidth;	{  ਭ }
  LengD : TLengD;	{     }
  Chars : TChars;	{ ⥫   }
  Offsets : TOffst;	{  ᬥ饭 }
  MaxW,			{ ᨬ쭠 ਭ ᨬ }
  MaxH,			{   ᨬ }
  AFileSize : Byte;	{  FileSize }
  xt, yt,	{  孨 㣮 ⠡ ᨬ }
  dxt,			{ ਭ ⪨ ⠡ ᨬ }
  dyt,			{  ⪨ }
  xr, yr,		{ न   }
  xe, ye,		{  孨 㣮 WE }
  xe2, ye2,		{ ࠢ  㣮 WE }
  yb,			{ न   }
  WidthX,		{ ࠢ ࠭ ᨬ }
  dxe,			{ ਭ ⪨ WE }
  dye,			{  ⪨ WE }
  dxm, dym : Integer;	{ ࠭   ࠡ祬  }
  VecE : array [1..250] of TCooE; {   WE }
  WR : Pointer;		{ ࠧ ⮣   }
  MouseF : Boolean;	{   㪠⥫  }
  CurM,			{ ⠭⭠ ᪠ 㪠⥫ }
  CurE : TMouseMask;	{ ᪠  ࠡ祬  }

const
  ChangeF : Boolean = false; {    }
  Head : TChar4 = 'PK'#8#8;

procedure OutChar(x0, y0 : Integer; c : Byte; dx, dy : Real);
{ 뢮 ᨬ 'c'   x, y  ⠡ dx, dy }
var
  PW : ^AW;
  k, x, y : Integer;

procedure Vector(W : Word);
{  ।  ᨬ }
var
  op : Word;
  xx, yy : Integer;
begin
  { 뤥塞  樨 }
  op:=W and $8080; if op=0 then Exit;
  W:=W xor op;
  { 뤥塞 न }
  yy:=W shr 8; xx:=W and $ff;
  if xx>63 then xx:=xx-128;
  if yy>63 then yy:=yy-128;
  { 砥 न ன 窨 }
  xx:=x0+Round(xx*dx); yy:=y0-Round(yy*dy);
  { 믮塞  }
  if op=$8080 then Line(x,y,xx,yy);
  x:=xx; y:=yy
end;

begin { OutChar }
  { 㥬 뢮  । ᨬ }
  if LengD[c]=0 then Exit;
  y0:=y0-dyt div 4;
  { 窠  न } x:=x0; y:=y0;
  { ⥫ ᨬ } PW:=Chars[c];
  { 稢 ᨬ }
  for k:=1 to LengD[c] div 2 do Vector(PW^[k])
end { OutChar };

procedure ClearWinEd; { 頥 ࠡ祥  }
var x, y : Integer;
begin
  SetViewPort(xe-dxm,ye-dym,xe2+dxm,ye2+dym,ClipOn);
  ClearViewPort; SetViewPort(0,0,GetMaxX,GetMaxY,ClipOn);
  { 뢮 ⨪ }
  for x:=0 to MaxW do for y:=0 to MaxH do
    PutPixel(xe+x*dxe,ye+y*dye,White);
  { 뢮   }
  SetColor(Cyan); yb:=ye+Succ(FontPara.UpperMargin)*dye;
  Line(xe,yb,xe2,yb);
  { 뢮 㪠⥫ ࠭ ᨬ }
  WidthX:=xe; Line(xe,ye,xe,ye2);
  {  ࠬ }
  SetColor(White); Rectangle(xe-dxm,ye-dym,xe2+dxm,ye2+dym)
end;

procedure Init;
{ 訢    CHR-䠩,  
   䠩, 樨 䨪  ᮧ ࠭ }

procedure FontRead(var Dest; Size : Word);
{ ⠥  䠩 F  ६ Dest Size 
   ஫ १.  訡 ਩
  蠥 ணࠬ }
var k : Word;
begin
  BlockRead(F,Dest,Size,k); if k=Size then Exit;
  WriteLn('訡  ⥭   䠩'); Halt
end;

procedure NameInput(var FName : string);
{   ஢  CHR-䠩 }
label loop, HeadErr;
var k : Byte;
begin
  WriteLn('ணࠬ ।஢  BGI-⮢'
		+' ଠ CHR. (C) 1993 . ஭');
  { ஢塞 ࠬ 饭 }
  if ParamCount<>0 then FName:=ParamStr(1) else FName:='';
  if FName='' then
  begin
    loop: {    訡   }
    Write('  CHR-䠩: '); ReadLn(FName);
    if FName='' then
    begin
      { ⮩  }
      Write('   (Y/N)? '); ReadLn(Fname);
      if (FName='') or (UpCase(FName[1])<>'Y') then Halt;
      FName:=''; Exit
    end
  end;
  if Pos('.',FName)=0 then FName:=FName+'.chr';
  { ஢塞 ⢮ 䠩 }
  Assign(F,FName); Reset(F,1);
  if IOresult<>0 then
  begin
    WriteLn(' '+FName+'  '); goto loop
  end;
  { ⠥  䠩 }
  FontRead(FontHead,SizeOf(FontHead));
  if FontHead.FontFileID<>Head then
  begin
    WriteLn('訡   䠩!'); goto loop
  end;
  { 饬 ᬥ饭  ࠬ஢   䠩 }
  with FontHead do
  begin
    { 稭  ⮣  } k:=5;
    while (k<SizeOf(FontHead)) and (B[k]<>$1a) do Inc(k);
    if B[k]=$1a then
    begin
      HeaderSize:=B[k+1]+B[k+2] shl 8;
      FileSize:=B[k+7]+B[k+8] shl 8; AFileSize:=k+7;
      { ⠥  ࠬ஢ }
      Seek(F,HeaderSize);
      FontRead(FontPara,SizeOf(FontPara));
      if FontPara.ParPrefix='+' then Exit else
	{  䨪 ࠬ஢ } goto HeadErr
    end
  end;
  {   ନ CopyrightEnd }
  HeadErr: Close(F);
  WriteLn('訡   䠩!'); goto loop
end;

procedure ReadData; { ⠥   䠩 }
var
  k : Integer;
  LastChar : Byte;
begin
  with FontPara do
  begin
    LastChar:=FirstChar+CharsCount-1;
    { 塞 ⠡ ᬥ饭 }
    for k:=0 to 255 do if k in [FirstChar..LastChar] then
      FontRead(Offsets[k],2) else Offsets[k]:=0;
    { 塞 ⠡ ਭ }
    MaxW:=0;
    for k:=0 to 255 do if k in [FirstChar..LastChar] then
    begin
      FontRead(Widths[k],1);
      if Widths[k]>MaxW then MaxW:=Widths[k]
    end
    else Widths[k]:=0;
    if MaxW<20 then MaxW:=20;
    { ⮢   뢠  }
    for k:=0 to 255 do LengD[k]:=0; { 塞 ⠡  }
    for k:=FirstChar to LastChar do
    begin
      if k=LastChar then
	LengD[k]:=FileSize-Offsets[k]-FontPara.DataOffset
	  else LengD[k]:=Offsets[k+1]-Offsets[k];
      if LengD[k]<>0 then
      begin
	GetMem(Chars[k],LengD[k]);
	FontRead(Chars[k]^,LengD[k])
      end
    end;
    Close(F)
  end
end;

procedure BuildScreen;
{ ॢ ᯫ  ᪨ ०,
   ⠭  ᮧ ࠭ }

procedure PutCur(var Cur : TMouseMask);
{  ࠦ   孥 㣫
  ࠭  ନ  㪠⥫  }
var
  B : Word;
  x, y : Byte;
begin
  for y:=0 to 15 do
  begin
    B:=0;
    for x:=0 to 15 do if GetPixel(x,y)<>GetBkColor
      then B:=B or ($8000 shr x);
    Cur[1,y]:=B; Cur[0,y]:=not B
  end
end;

var
  Sz : Word;
  FF : file;
  Font : Pointer;
  HFont : Byte;
  S : string;
  N, d, r, e, k, x, y : Integer;
const
  txt : array [1..6] of string[10] = (
	' ⠡', ' ⠡', '',
	'ࠧ', '࠭',	'室');
  Items : array [1..6] of MouseItemType = (
    (x1:1;  y1:1; x2:13; y2:2; Butt:LeftButton; Key:1 shl 8),
    (x1:14; y1:1; x2:25; y2:2; Butt:LeftButton; Key:2 shl 8),
    (x1:26; y1:1; x2:37; y2:2; Butt:LeftButton; Key:3 shl 8),
    (x1:38; y1:1; x2:49; y2:2; Butt:LeftButton; Key:4 shl 8),
    (x1:50; y1:1; x2:61; y2:2; Butt:LeftButton; Key:5 shl 8),
    (x1:61; y1:1; x2:80; y2:2; Butt:LeftButton; Key:6 shl 8));
begin { BuildScreen }
  d:=Detect; InitGraph(d,r,''); e:=GraphResult;
  if e<>GrOk then
  begin
    WriteLn('訡  ⠭ ᪮ ०'); Halt
  end;
  { 롨ࠥ   ᨬ  ࠧ襭 ࠭ }
  case GetMaxY of
    349: HFont:=14; 479..1024: HFont:=19 else HFont:=8
  end;
  with FontPara do MaxH:=UpperMargin-LowerMargin+1;
  { ।塞 ࠭ ࠡ祣  }
  dye:=Succ(GetMaxY) div (5*MaxH div 4); {  ⪨ }
  dxe:=Succ(GetMaxX) div (2*MaxW); { ਭ ⪨ }
  xe:=dxe div 3; { 饭 ᫥ }
  ye:=2*HFont; { 饭 ᢥ }
  xe2:=xe+MaxW*dxe; ye2:=ye+MaxH*dye; { ࠢ  㣮 }
  { ।塞 ࠧ 㪠⥫ 
     ࠡ祬   ନ㥬  ᪨ }
  dxm:=xe; dym:=dye div 3;
  { ஢塞 稥  }
  if not InitMouse then
  begin
    CloseGraph;
    WriteLn('  - ணࠬ   ࠡ!'); Halt
  end;
  { ⮢ ⠭ 㪠⥫ }
  ShowMouse;
  MouseGoToXY(0,0); {   孨 㣮 }
  PutCur(CurM); {  ࠧ }
  HideMouse;
  { ⥫-⨪  ࠡ祣  }
  Rectangle(0,0,2*dxm,2*dym); PutCur(CurE);
  { 稢 ࠡ祥  }
  ClearWinEd;
  { ⮢ न  ७ ᨬ }
  xr:=(xe2-xe) div 2; yr:=GetMaxY-MaxH;
  Sz:=ImageSize(xr,yr,xr+MaxW,yr+MaxH);
  GetMem(WR,Sz); GetImage(xr,yr,xr+MaxW,yr+MaxH,WR^);
  {  ⠡ ᨬ }
  xt:=xe+(MaxW+1)*dxe; {  孨 }
  yt:=ye; {  ⠡ ᨬ }
  dxt:=GetMaxX div 32; {   ਧ⠫ }
  dyt:=GetMaxY div 20; {   ⨪ }
  SetColor(White);
  { 뢮 ᨬ }
  for N:=0 to 255 do with FontPara do
  begin
    x:=xt+(N mod 16)*dxt; y:=yt+(N div 16)*dyt;
    if LengD[N]<>0 then
    begin
      SetColor(White);
      OutChar(x,y+dyt,N,dxt/MaxW,dyt/(MaxH+5))
    end
    else begin
      { 뢮 騥 ᨬ }
      SetColor(DarkGray); OutTextXY(x,y+dyt-8,Chr(N))
    end
  end;
  { 㦠   䠩 8xH.fnt }
  Str(HFont,S); S:='8x'+S+'.fnt'; Assign(FF,S); Reset(FF,1);
  if IOresult<>0 then
  begin
    CloseGraph; WriteLn(' ⮢ 䠩 '+S); Halt
  end;
  Sz:=System.FileSize(FF); GetMem(Font,Sz);
  BlockRead(FF,Font^,Sz,r); Close(FF);
  if r<>Sz then
  begin
    CloseGraph; WriteLn('訡 ⥭ 䠩 '+S); Halt
  end;
  { 㥬   ७砥 /뢮 }
  SetFont(Font,8,HFont); GraphWriteOn;
  { 뢮 ப  }
  Colors(Black,LightGray);
  for k:=1 to 6 do with Items[k] do SetWindow(x1,y1,x2,y2-1,
    EmptyBorder,txt[k],false,false,false);
  { 樨㥬  }
  SetMouseItem(6,Items); ShowMouse;
  Window(1,1,80,25); TextRatioY:=HFont
end { BuildScreen };

procedure NewFile(var FName : string);
{   CHR-䠩 }
var
  Name : string;
  hh : ShortInt;
  y : string[1];
  h, k : Byte;
const
  t1 = 'ᨬ쭠  ᨬ   : ';
  t2 = 'ﭨ   ஬ ᨬ: ';
  t3 = 'ᨬ쭠 ਭ: ';
  t4 = '    Font V1.1 Jan 12, 1989';
  t5 = #13#10;
  t6 = 'Copyright (c) 1987,1988 Borland International';
begin
  {    ࠬ  }
  repeat
    Write(' 4-㪢  : ':55);
    ReadLn(Name); while Length(Name)<4 do Name:=Name+'0';
    Name[0]:=#4;
    for k:=1 to 4 do Name[k]:=UpCase(Name[k]);
    Write(t1:55); ReadLn(h); h:=h and 63;
    Write(t2:55); ReadLn(hh); if hh>0 then hh:=-hh;
    Write(t3:55); ReadLn(MaxW); MaxW:=MaxW and 63;
    MaxH:=h-hh; WriteLn;
    WriteLn('㤥 ᮧ    '+Name+
      '  ᫥騬 ࠬࠬ:');
    WriteLn(t1:55,h); WriteLn(t2:55,hh); WriteLn(t3:55,MaxW);
    Write(' (Y/N, 㬫. Y)? '); ReadLn(y)
  until (y<>'') or (UpCase(y[1])<>'N');
  { ⮢  }
  for k:=1 to 128 do FontHead.B[k]:=0;
  for k:=1 to 16 do FontPara.H2[k]:=0; FName:=Name+'.chr';
  with FontHead do
  begin
    FontFileID:=Head; Name:='BGI '+Name+t4+t5+t6+t5+#0;
    for k:=1 to Length(Name) do B[k+4]:=Ord(Name[k]);
    AFileSize:=k+12; Name:=#$80#0+FName;
    Name[0]:=#$1a; { CopyrightEnd }
    Name[7]:=#0; { Lo[FileSize] }
    Name[8]:=#0; { Hi[FileSize] }
    Name[9]:=#1; { V1. }
    Name[10]:=#0;
    Name[11]:=#1; { V.1 }
    for k:=0 to 11 do B[AFileSize-7+k]:=Ord(Name[k])
  end;
  { ⮢  ࠬ஢ }
  with FontPara do
  begin
    ParPrefix:='+'; CharsCount:=0;
    FirstChar:=0; DataOffset:=16;
    FillFlag:=0; UpperMargin:=h; LowerMargin:=hh
  end;
  { ⮢ ⠡  }
  for k:=0 to 255 do LengD[k]:=0;
  Assign(F,FName)
end;

begin { Init }
  repeat
    {   ஫㥬  䠩 }
    NameInput(FName);
    if FName<>'' then ReadData { ⠥   䠩 }
      else NewFile(FName) {   䠩 }
  until FName<>'';
  BuildScreen {  ࠭ }
end { Init };

procedure SaveFont; { ࠭   䠩 }

procedure Alarm; { 頥  訡  }
var
  Sz : Word;
  P : Pointer;
  C : Char;
  x1, y1, x2, y2 : Integer;
begin
  HideMouse; Colors(White,Red); Window(15,12,65,14);
  GetWindGraphCoo(x1,y1,x2,y2); Sz:=ImageSize(x1,y1,x2,y2);
  GetMem(P,Sz); GetImage(x1,y1,x2,y2,P^);
  SetWindow(15,12,65,14,DoubleBorder,
    '    ',true,true,true);
  Write('訡 㯠  䠩!':36); ShowMouse;
  while not KeyPressed and not MousePressed do;
  while KeyPressed do C:=ReadKey;
  while MousePressed do;
  HideMouse; PutImage(x1,y1,P^,NormalPut);
  ShowMouse; FreeMem(P,Sz); Window(1,1,80,25)
end;

function WriteFile(var Source; S : Word) : Boolean;
{ 뢠  䠩 S   ६
  Source  ஫ १ }
var k : Word;
begin
  BlockWrite(F,Source,S,k); WriteFile:=S=k;
  if S<>k then Alarm
end;

var
  k : Integer;
  MinChr, MaxChr : Byte;
  W, Offs, PredO : Word;
label P_Ex;
begin { SaveFont }
  if not ChangeF then Exit;
  TextBackGround(Red); TextColor(Yellow);
  GoToXY(52,25); Write('  ...');
  { ।塞 砫 ᨬ }
  MinChr:=0;
  while (MinChr<255) and (LengD[MinChr]=0) do Inc(MinChr);
  if MinChr=255 then goto P_Ex;
  { ।塞 ᫥ ᨬ }
  MaxChr:=MinChr; k:=MaxChr;
  while k<=255 do
  begin
    if LengD[k]<>0 then MaxChr:=k;
    Inc(k)
  end;
  { ४㥬  ᨬ  뢠
     㦠  }
  FileSize:=0;
  for k:=MinChr to MaxChr do if LengD[k]=0 then
  begin
    { ⮩ ᨬ }
    Widths[k]:=Widths[MinChr]; Inc(FileSize,LengD[MinChr])
  end
  else Inc(FileSize,LengD[k]);
  { ।塞 ᬥ饭  䠩 }
  Offs:=3*(MaxChr-MinChr+1)+16;
  { ४㥬 ⥫  }
  with FontPara do
  begin
    FirstChar:=MinChr; CharsCount:=MaxChr-MinChr+1;
    DataOffset:=Offs; FileSize:=FileSize+16+3*CharsCount
  end;
  { 뢠  }
  with FontHead do
  begin
    B[AFileSize]:=Lo(FileSize); B[AFileSize+1]:=Hi(FileSize)
  end;
  { ⮢ 䠩 }
  ReWrite(F,1);
  if IOresult<>0 then
  begin
    Alarm; goto P_Ex
  end;
  if not WriteFile(FontHead,SizeOf(FontHead)) then goto P_Ex;
  { 뢠 ⥫ }
  if not WriteFile(FontPara,SizeOf(FontPara)) then goto P_Ex;
  { 뢠 ⠡ ᬥ饭 }
  PredO:=Offs;
  for k:=MinChr to MaxChr do
  begin
    W:=Offs-PredO;
    if LengD[k]<>0 then Inc(Offs,LengD[k])
      else Inc(Offs,LengD[MinChr]);
    if not WriteFile(W,2) then goto P_Ex
  end;
  { 뢠 ⠡ ਭ }
  for k:=MinChr to MaxChr do
    if not WriteFile(Widths[k],1) then goto P_Ex;
  { 뢠  }
  for k:=MinChr to MaxChr do if LengD[k]<>0 then
    if not WriteFile(Chars[k]^,LengD[k]) then goto P_Ex else
      else if not WriteFile(Chars[k]^,LengD[MinChr])
	then goto P_Ex;
  Close(F); ChangeF:=false;
  P_Ex: TextBackGround(16);
  GoToXY(52,25); Write('                 ')
end { SaveFont };

procedure Run;
{ ᭮ ࠡ: ⥭  
    맮 㦭 楤 }
var
  mpf : Boolean; {  १  }
  PW : ^AW;
  W, op : Word;
  x0g, y0g, x1g, y1g, { न १  }
  bm, xm, ym, b, x, y : Integer;

procedure RepChar; {  ᨬ    }
var k : Word;
begin
  { ࠥ ஥ ࠦ }
  PutImage(xr,yr,WR^,NormalPut);
  { ନ㥬  }
  SetWriteMode(NormalPut); SetColor(White);
  for k:=1 to NVecE do with VecE[k],FontPara do
    Line(xr+x1 div dxe,yr+MaxH+LowerMargin-(yb-y1) div dye,
      xr+x2 div dxe,yr+MaxH+LowerMargin-(yb-y2) div dye)
end;

function Tabl(var N : Byte) : Boolean;
{ 롨ࠥ ᨬ  ⠡. 頥
   ᨬ  false  ࠢ  }
var
  nx, ny, nxx, nyy : Byte;
  Sz : Word;
  P : Pointer;
  x, y, k, xx, yy, ddx, ddy : Integer;
begin
  HideMouse;
  ddx:=dxt div 2; {  ਭ }
  ddy:=dyt div 2; {   }
  x:=xt+ddx; y:=yt+ddy; { 砫 ᨬ }
  nx:=0; {  ⮫ }
  ny:=0; {  ப }
  MouseGoToXY(x,y); MouseWindow(x,y,x+15*dxt,y+15*dyt);
  { 뤥塞 ᨬ }
  Sz:=ImageSize(x-ddx,y-ddy,x+ddx,y+ddy);
  GetMem(P,Sz); GetImage(x-ddx,y-ddy,x+ddx,y+ddy,P^);
  PutImage(x-ddx,y-ddy,P^,NotPut);
  while MousePressed do; { 뢠  }
  while not MousePressed do
  begin
    { 饥  }
    GetMouseState(k,xx,yy);
    nxx:=(xx-xt) div dxt; nyy:=(yy-yt) div dyt;
    if (nx<>nxx) or (ny<>nyy) then
    begin
      { 諨    }
      PutImage(x-ddx,y-ddy,P^,NormalPut);
      GoToXY(60,25); TextColor(White);
      TextBackGround(LightRed); Write(nyy*16+nxx:4,' ');
      nx:=nxx; ny:=nyy; x:=xt+nx*dxt+ddx; y:=yt+ny*dyt+ddy;
      GetImage(x-ddx,y-ddy,x+ddx,y+ddy,P^);
      PutImage(x-ddx,y-ddy,P^,NotPut)
    end
  end;
  {  : ⠭ ࠭ }
  PutImage(x-ddx,y-ddy,P^,NormalPut); FreeMem(P,Sz);
  TextBackGround(16); GoToXY(60,25); Write('     ');
  GetMouseState(k,xx,yy); { k -   }
  while MousePressed do; {  ᪠ }
  N:=ny*16+nx; Tabl:=k=LeftButton; ShowMouse;
  MouseScreen { ᢮  }
end;

procedure ClearWE; { 頥 ࠡ祥  }
begin
  ClearWinEd; PutImage(xr,yr,WR^,NormalPut);
  NVecE:=0; WidthX:=0
end;

procedure GetChar; {  ᨬ  ⠡ }
var
  k : Integer;
  N : Byte;
  W, op : Word;
  xx, yy : ShortInt;
begin
  if not Tabl(N) then Exit; { 室  ࠢ  }
  ClearWE; { 頥 ࠡ祥  }
  PW:=Chars[N]; {  ⥫ }
  x:=0; y:=0; { 砫 न  }
  SetColor(Yellow); SetWriteMode(XOrPut);
  {    }
  for k:=1 to LengD[N] div 2 do
  begin
    W:=PW^[k]; { । ᫮ }
    op:=W and $8080; {  樨 }
    W:=W xor op;
    xx:=W and 127; { न X }
    yy:=W shr 8; { न Y }
    if yy>63 then yy:=yy-128;
    if op=$8080 then
    {   }
    begin
      Inc(NVecE); { ⢮ ஢ }
      with VecE[NVecE] do
      begin
	{ ନ㥬   }
	x1:=xe+x*dxe; y1:=yb-y*dye;
	x2:=xe+xx*dxe; y2:=yb-yy*dye;
	Line(x1,y1,x2,y2) { ⨬   ࠡ祬  }
      end
    end;
    x:=xx; y:=yy {    }
  end;
  { ⨬ ࠢ ࠭ ᨬ }
  WidthX:=xe+Widths[N]*dxe; SetColor(Cyan);
  Line(WidthX,ye,WidthX,ye2);
  RepChar { 塞 ᨬ    }
end;

procedure SetChar; { 頥 ᨬ  ⠡ }
var
  k, xc, yc : Integer;
  N : Byte;
  W, op : Word;
  Data : AW;
  x, y, xx1, yy1, xx2, yy2 : ShortInt;
begin
  if not Tabl(N) then Exit;
  { 塞  ⥫ }
  if LengD[N]<>0 then FreeMem(Chars[N],LengD[N]);
  Widths[N]:=(WidthX-xe) div dxe; LengD[N]:=0;
  {   ࠬ }
  x:=0; y:=0;
  for k:=1 to NVecE do with VecE[k] do
  begin
    xx1:=(x1-xe) div dxe; xx2:=(x2-xe) div dxe;
    yy1:=(yb-y1) div dye; yy2:=(yb-y2) div dye;
    if (x<>xx1) or (y<>yy1) then
    begin
      {  室 }
      if yy1<0 then Inc(yy1,128);
      Inc(LengD[N]); Data[LengD[N]]:=yy1 shl 8+xx1 or $80
    end;
    x:=xx2; y:=yy2; if yy2<0 then Inc(yy2,128);
    Inc(LengD[N]); Data[LengD[N]]:=yy2 shl 8+xx2 or $8080
  end;
  { ନ㥬 室   ᨬ }
  Inc(LengD[N]); Data[LengD[N]]:=Widths[N] or $80;
  Inc(LengD[N]);
  Data[LengD[N]]:=0; {   }
  { 뢠   }
  LengD[N]:=2*LengD[N];
  GetMem(Chars[N],LengD[N]); Move(Data,Chars[N]^,LengD[N]);
  { ⨬ ᨬ  ⠡ }
  HideMouse; xc:=xt+(N mod 16)*dxt; yc:=yt+(N div 16)*dyt;
  SetFillStyle(SolidFill,Black);
  Bar(xc,yc,xc+dxt-1,yc+dyt-1); SetColor(White);
  SetWriteMode(NormalPut);
  OutChar(xc,yc+dyt,N,dxt/MaxW,dyt/(MaxH+5));
  SetColor(Yellow); SetWriteMode(XOrPut);
  ShowMouse; ChangeF:=true
end;

function Ned(var x, y : Integer) : Boolean;
{ 頥 true  न 㧫,
  ᫨     ⭮ }
var Is : Boolean;
begin
  Is:=false; y:=ye;
  repeat
    x:=xe;
    repeat
      Is:=MouseIn(x-dxm,y-dym,x+dxm,y+dym);
      if not Is then Inc(x,dxe);
    until Is or (x>xe2);
    if not Is then Inc(y,dye)
  until Is or (y>ye2);
  Ned:=Is
end;

procedure MouseInNed; { ஢ ⬥  㧫 ⪨ }
var xn, yn : Integer;
begin
  if not Ned(xn,yn) then Exit; {    㧥 }
  HideMouse; while MousePressed do;
  MouseGoToXY(xn,yn);
  if not mpf then
  begin
    {  㧥 }
    mpf:=true; x0g:=xn; y0g:=yn; x1g:=x0g; y1g:=y0g;
    SetColor(Yellow); SetWriteMode(XOrPut);
    MouseWindow(xe,ye,xe2,ye2);
    MouseGraphCursor(CurE,dxm,dym); ShowMouse
  end
  else begin
    { ନ㥬   }
    mpf:=false;
    if (x0g<>x1g) or (y0g<>y1g) then Line(x0g,y0g,x1g,y1g);
    MouseScreen;
    if (x0g<>xn) or (y0g<>yn) then
    begin
      { 頥 ।  }
      Inc(NVecE);
      with VecE[NVecE] do
      begin
	x1:=x0g; y1:=y0g; x2:=xn; y2:=yn;
	Line(x1,y1,x2,y2); RepChar
      end;
      { ஢塞 ਭ ᨬ }
      if x0g>xn then xn:=x0g;
      if xn>WidthX then
      begin
	{ 頥 ࠢ ࠭ }
	SetColor(Cyan); SetWriteMode(XOrPut);
	Line(WidthX,ye,WidthX,ye2); WidthX:=xn+4*dxe;
	if WidthX>xe2 then WidthX:=xe2;
	Line(WidthX,ye,WidthX,ye2); SetColor(Yellow)
      end;
      MouseGraphCursor(CurM,0,0); ShowMouse
    end
  end
end;

procedure MouseInLine; { ஢ ⬥  }
var
  Is, Sign : Boolean;
  k : Word;
  k0, y0 : Real;
  x1m, y1m, x2m, y2m, dx, dy, x, y, N : Integer;
label loop;
begin
  if mpf then
  begin
    { ⮦ १  }
    HideMouse; mpf:=false;
    if (x0g<>x1g) or (y0g<>y1g) then Line(x0g,y0g,x1g,y1g);
    MouseGraphCursor(CurM,0,0); ShowMouse; MouseScreen; Exit
  end;
  if NVecE=0 then Exit; { ⮥ ࠡ祥  }
  loop: GetMouseState(x,x1m,y1m);
  if not MousePressed and MouseF then
  begin
    HideMouse; MouseGraphCursor(CurM,0,0);
    ShowMouse; MouseScreen; MouseF:=false; Exit
  end;
  x2m:=x1m+dxm; y2m:=y1m+dym; x1m:=x1m-dxm; y1m:=y1m-dym;
  { ஢塞   }
  n:=1; Is:=false;
  repeat
    with VecE[N] do if (x1=x2) and (x1>=x1m) and (x1<=x2m)
      { ⨪  }
      then Is:=((y1>=y2m) and (y2<=y1m)) or
	       ((y1<=y1m) and (y2>=y2m)) else
	{ ਧ⠫  }
	if (y1=y2) and (y1>=y1m) and (y1<=y2m) then
	   Is:=((x1>=x1m) and (x2<=x2m)) or
	       ((x1<=x2m) and (x2>=x1m)) else
	{   }
	if (((y1>=y2m) and (y2<=y1m)) or ((y1<y1m) and
	   (y2>=y2m))) and (((x1>=x1m) and (x2<=x2m)) or
	   ((x1<=x2m) and (x2>=x1m))) then
    begin
      k0:=(y2-y1)/(x2-x1); y0:=y1-k0*x1;
      for x:=x1m to x2m do if not Is then
      begin
	y:=Round(k0*x+y0); Is:=(y>=y1m) and (y<=y2m);
	if not Is then if x=x1m then Sign:=y<y1m else
	  Is:=(Sign and (y1>y1m)) or (not Sign and (y<y1m))
      end
    end;
    if not Is then Inc(N)
  until Is or (N>NVecE);
  if Is then
  begin
    { 塞  }
    HideMouse; SetColor(Yellow); SetWriteMode(XOrPut);
    with VecE[N] do Line(x1,y1,x2,y2); { ࠥ  }
    if NVecE>1 then { ६頥  }
      for N:=N to NVecE-1 do VecE[N]:=VecE[N+1];
    Dec(NVecE); RepChar;
    if NVecE>1 then
    begin
      MouseGraphCursor(CurE,dxm,dym);
      MouseWindow(xe-dxm,ye-dym,xe2+dxm,ye2+dym);
      MouseF:=true
    end
    else begin
      MouseGraphCursor(CurM,0,0); MouseScreen; MouseF:=false
    end;
    ShowMouse; if MouseF then goto loop
  end
  else if MouseF then goto loop else
    if (WidthX>=x1m) and (WidthX<=x2m) then
  begin
    { ६頥 ࠢ ࠭ }
    SetColor(Cyan); SetWriteMode(XOrPut);
    HideMouse; MouseGraphCursor(CurE,dxm,dym);
    ShowMouse; MouseWindow(xe,ye,xe2,ye2);
    while MousePressed do
    begin
      GetMouseState(N,x1m,y1m);
      if xe+dxe*Round((x1m-xe)/dxe)<>WidthX then
      begin
	HideMouse; Line(WidthX,ye,WidthX,ye2);
	WidthX:=xe+dxe*Round((x1m-xe)/dxe);
	Line(WidthX,ye,WidthX,ye2); ShowMouse
      end
    end;
    MouseScreen; HideMouse;
    MouseGraphCursor(CurM,0,0); ShowMouse
  end
end;

procedure MouseMove; { ஫ ६饭  }
begin
  if mpf and ((xm<>x1g) or (ym<>y1g)) then
  begin
    { ନ㥬 १  }
    HideMouse;
    { ࠥ  }
    if (x0g<>x1g) or (y0g<>y1g) then Line(x0g,y0g,x1g,y1g);
    {  न  }
    x1g:=xm; y1g:=ym;
    if (x0g<>x1g) or (y0g<>y1g) then Line(x0g,y0g,x1g,y1g);
    ShowMouse
  end
end;

procedure Pattern;
{ 롨ࠥ  頥  ࠡ祥  ࠧ }
var
  k, op, W : Word;
  PW : ^AW;
  N : Byte;
  x, y, xx, yy : Integer;
begin
  if not Tabl(N) then Exit; { 室  ࠢ  }
  SetColor(LightGray);
  PW:=Chars[N]; {  ⥫ }
  x:=xe; y:=yb; { 砫 न  }
  {    }
  for k:=1 to LengD[N] div 2 do
  begin
    W:=PW^[k]; { । ᫮ }
    op:=W and $8080; {  樨 }
    W:=W xor op;
    xx:=W and 127; { न X }
    yy:=W shr 8; { न Y }
    if yy>63 then yy:=yy-128;
    xx:=xe+xx*dxe; yy:=yb-yy*dye;
    if op=$8080 then Line(x,y,xx,yy);
    {    }
    x:=xx; y:=yy
  end;
  SetColor(Yellow)
end;

begin { Run }
  SetWriteMode(XOrPut);
  NVecE:=0; {  ஢  WE }
  mpf:=false; {    }
  SetColor(Yellow);
  GetMouseState(bm,xm,ym); { 砫쭮 ﭨ  }
  { ᪮ 横   "室" }
  while true do
  begin
    { ஢塞 롮    }
    if KeyOrMousePressed then case ReadKeyOrMouse of
      #0: case ReadKeyOrMouse of
	#1: GetChar; #2: SetChar; #3: ClearWE;
	#4: Pattern; #5: SaveFont; #6: Exit
      end
    end;
    { ஢塞 ⥪饥 ﭨ  }
    GetMouseState(b,x,y);
    if (b<>bm) or (x<>xm) or (y<>ym) then
      if MousePressed and MouseIn(xe,ye,xe2,ye2) then
    case b of
      { ஫㥬  }
      LeftButton: MouseInNed; RightButton: MouseInLine
    end
    else MouseMove; { ஫㥬 ६饭 }
    xm:=x; ym:=y; bm:=b
  end
end { Run };

procedure Done; { 襭 ࠡ }
begin
  SaveFont; CloseGraph
end;

begin
  Init; Run; Done
end { Edit_CHR }.