program Fnt_Genr;
{    ࠡ  F_GrText
  -------------------------------------------
    롨ࠥ  ᨬ  ⨯ ᪮
  .  砥 ࠡ  ࠬ VGA/SVGA ஬ 䠩
  8x16.fnt ᮧ   䠩 8x19.fnt,  室 
  8x19, 騩  筮 㫨஢ ⥪⮢  
  ᪮ ࠭.  ,  ன ந ,
  ᮧ   ॢ  8x16  8x19 ⢫﫨
   ࠧ묨 ணࠬ.   ணࠬ -   -
  . ஬ ⮣  ᮧ 䠩  ७
  .p_f,  室 , ଫ   ⨯஢
  ⠭  ࡮-᪠.    뢠 
   .fnt-䠩,  ࠧ   ணࠬ }
uses Graph;
type ab = array [0..MaxInt] of Byte;
var
  f : file;
  d, r, e, x0, y0 : Integer;
  p : ^ab;
  s : string;
  k, x, y, b, h, s1 : Byte;

procedure Convert_16_to_19;
type
  t16 = array [0..15] of Byte;
  t19 = array [0..18] of Byte;
  t16_1 = array [0..7, 0..15, 0..18] of Byte;
  t19_1 = array [0..7, 0..18, 0..15] of Byte;
var
  f16 : file of t16;
  f19 : file of t19;
  c16 : t16;
  c19 : t19;
  a16 : t16_1;
  a19 : t19_1 absolute a16;
begin
  Assign(f16,'8x16.fnt'); Reset(f16);
  Assign(f19,'8x19.fnt'); ReWrite(f19); ClearDevice;
  { ।塞 砫 न - }
  x0:=0; y0:=0;
  { ᭮ 横 ८ࠧ }
  while not Eof(f16) do
  begin
    { ⠥ । ࠧ 8x16 }
    Read(f16,c16);
    { 㥬  ᫥-ࠢ-ᢥ-
         8x16 }
    for y:=0 to 15 do for x:=0 to 7 do
    begin
      { 뤥塞 㦭  }
      b:=Ord(c16[y] and (128 shr x)<>0);
      if b<>0 then PutPixel(x0+x,y0+y,White);
      { ନ㥬 19   㫥 }
      for k:=0 to 18 do a16[x,y,k]:=b
    end;
    {  ࠦ 8x19 }
    for y:=0 to 18 do
    begin
      b:=0;
      for x:=0 to 7 do
      begin
	s1:=0; { 砫쭮 祭 㬬 }
	{ 㬬㥬  }
	for k:=0 to 15 do s1:=s1+a19[x,y,k];
	{ ஢塞 㬬 }
	if s1>9 then
	begin
	  { 設⢮ ⮪ 襭 - 頥
	      뢮 ᥫ }
	  b:=b or (128 shr x); PutPixel(x0+9+x,y0+y,White)
	end
      end;
      c19[y]:=b
    end;
    { 뢠  䠩 }
    Write(f19,c19);
    {  - }
    Inc(x0,20);
    if x0>640 then
    begin
      x0:=0; Inc(y0,20)
    end
  end;
  Close(f16); Close(F19)
end;

procedure Font_to_PAS;
{ ଫ    ⨯஢ ⠭ }

function Hex8(x, y : Integer) : string;
const HD : array [0..15] of Char = '0123456789ABCDEF';
begin
  Hex8 := HD[p^[x*h+y-1] shr 4] + HD[p^[x*h+y-1] and $0f]
end;

var
  ft : Text;
  i, j : Integer;
begin
  Str(h,s); Assign(ft,'fnt_8x'+s+'.p_f');
  ReWrite(ft); WriteLn(ft,'const');
  WriteLn(ft,'  Font_8x'+s+' : array [0..255, 1..'+s+
	'] of Byte = ('); Write(ft,'    (');
  for i:=0 to 255 do
  begin
    for j:=1 to 8 do
    begin
      Write(ft,'$'+Hex8(i,j));
      if j<>8 then Write(ft,',') else if (h=8) and (i<>255)
	then Write(ft,'),') else if h=8 then WriteLn(ft,'));')
    end;
    if h<>8 then
    begin
      WriteLn(ft,','); Write(ft,'     ');
      for j:=1 to h-8 do
      begin
	Write(ft,'$'+Hex8(i,j+8));
	if j<>h-8 then Write(ft,',') else Write(ft,')')
      end;
      if i=255 then WriteLn(ft,');') else Write(ft,',')
    end;
    if i<>255 then
    begin
      WriteLn(ft); Write(ft,'    (')
    end
  end;
  WriteLn(ft); WriteLn(ft,'...'); WriteLn(ft);
  WriteLn(ft,'SetFont(@Font_8x'+s+',8,'+s+');'); Close(ft)
end;

begin
  d:=Detect; InitGraph(d,r,''); e:=GraphResult;
  if e<>GrOk then
  begin
    WriteLn('訡  ⠭ ᪮ ०'); Halt
  end;
  { ।塞   }
  case d of
    EGA: h:=14; VGA: h:=16 else h:=8
  end;
  { ࢨ㥬 㦭    뢠
    䠩   8xh.fnt,  h -   }
  GetMem(p,256*h); Str(h,s); s:='8x'+s+'.fnt';
  Assign(f,s); ReWrite(f,1);
  { ।塞 砫 न - }
  x0:=0; y0:=20;
  { ࠢ塞 ⥪⮢ 뢮  孨  㣮 }
  asm
	mov	ah,2
	xor	bh,bh
	xor	dx,dx
	int	10h
  end;
  { ᭮ 横 ᮧ ⮢ ࠧ ᨬ }
  for k:=0 to 255 do
  begin
    { 뢮 । ᨬ }
    asm
	mov	ah,09h
	mov	al,k
	mov	bx,15
	mov	cx,1
	int	10h
    end;
    { 㥬 ᮧ ࠦ
      ᫥-ࠢ-ᢥ- }
    for y:=0 to h-1 do
    begin
      b:=0; { 砫쭮 祭 ।  }
      for x:=0 to 7 do if GetPixel(x,y)<>GetBkColor then
      begin
	{ ନ㥬   }
	b:=b or (128 shr x);
	{ ᨬ ᨬ   孥 㣫 ࠭ }
	PutPixel(x,y,GetBkColor);
	{  塞   }
	PutPixel(x0+x,y0+y,White)
      end;
      p^[k*h+y]:=b {   }
    end;
    {   - ᨬ }
    Inc(x0,10);
    if x0>GetMaxX then
    begin
      x0:=0; Inc(y0,20)
    end
  end;
  { 뢠   䠩 }
  BlockWrite(f,p^,256*h); Close(f); Font_to_PAS;
  if h=16 then
  begin
    {  䠩 8x19.fnt }
    FreeMem(p,256*h); Convert_16_to_19; h:=19;
    GetMem(p,256*h); Assign(f,'8x19.fnt'); Reset(f,1);
    BlockRead(f,p^,256*h); Close(f); Font_to_PAS
  end;
  CloseGraph; FreeMem(p,256*h)
end { Fnt_Genr }.