(********************************************)
(*    / *)
(*              *)
(********************************************)

{$A+,B-,F-,I-,N-,O-,Q-,R-,S-}

{ !  ᯨ᪥ 'uses'  F_GrText ᫥
  㪠뢠 ᫥  Crt,  楤 TextColor,
  TextBackGround, Window  .. - ࠡ   !
	 ணࠬ Mouse_T ਢ ਬ ᮢ⭮
  ᯮ짮 㫥 F_GrText  F_Text }

unit F_GrText;

	INTERFACE

uses Crt, Graph, Dos;

const
  AppHandle : Boolean = true;	{  ࠢ ⭮
				  প CGA/EGA/VGA }
  EscFlag : Boolean = false;	{ 襭   ESC }
{ ⠭  㪠 ⨯ ࠬ  楤 SetWindow }
  EmptyBorder = 0;
  SingleBorder = 1;
  DoubleBorder = 2;
{ ᨢ  稢 ࠬ (ୠ⨢ ஢) }
  BorderChar : array [0..2, 1..6] of Char =
	((' ',' ',' ',' ',' ',' '),
	 ('','','','','',''),
	 ('','','','','',''));

procedure ClrScr; { 頥 ⥪⮢   ࠭ }

procedure Colors(Text, Back : Byte);
{ ⠭ 梥 ⥪  䮭 }

function GetMaxChar : Byte;
{ 頥 ᨬ쭮 ᫮ ᨬ  ப }

function GetMaxLine : Byte;
{ 頥 ᨬ쭮 ᫮ ப  ࠭ }

procedure GetWindGraphCoo(var x1, y1, x2, y2 : Integer);
{ 頥 ᪨ न ⥪⮢  }

procedure GoToXY(x, y : Byte); { ⠭  }

function GraphCooX(x : Byte) : Integer;
{ 頥  न   ⥪⮢ X }

function GraphCooY(y : Byte) : Integer;
{ 頥  न   ⥪⮢ Y }

procedure GraphWriteOn;
{ ७砥 ⠭  /뢮
   楤 GraphWrite  GraphRead }

procedure GraphWriteOff;
{ ⠭ ⠭  /뢮 }

procedure SetFont(Fnt : Pointer; x, y : Byte);
{ ⠭ ⥪騩   ⥪⮢ /뢮 }

procedure Scrolling(N : Integer);
{ ⢫ ᤢ ᮤন    
   N ப; ᫨ N < 0  ᤢ ந  }

procedure TextBackGround(Color : Byte);
{ ⠭ 梥 䮭.  梥 䮭 0 ᨬ 
  뢠  ࠦ.  ⠭ ୮ 䮭
  ᫥  ⢥ 梥 䮭 ᯮ짮 16 }

procedure TextColor(Color : Byte);
{ ⠭ 梥 ᨬ }

function TextCooX(x : Integer) : Byte;
{ 頥  ⥪⮢ न  ᪮ X }

function TextCooY(y : Integer) : Byte;
{ 頥  ⥪⮢ न  ᪮ Y }

function WhereX : Byte; { 頥 न X  }

function WhereY : Byte; { 頥 न Y  }

procedure Window(x1, y1, x2, y2 : Byte);
{ ⠭ ⥪⮢  }

procedure SetWindow(x1, y1, x2, y2, Border : Byte;
	Header : string; Clip, Build, Play : Boolean);
{ ⠭ ⥪⮢ , 頥 ,
   ࠬ, 뢮  Header
    Build = true -  "ࠧ稢"
    Clip = true - ਧ 窨
    Play = true - 㪮 ᮯ஢  ࠧ稢 }

function RegisterCHRFile(S : string) : Integer;
{     䠩 S
   頥 浪   }

function RegisterCHRFont(Font : Pointer) : Integer;
{      
  Font  頥 浪   }

procedure OutString(S : string; Font : Integer;
	Angle : Integer; MX, MY : Real);
{ 뢮   ୮  
  Font ப S  ⮬  㣮 Angle 
  c ⠡묨 樥⠬ MX, MY }

	IMPLEMENTATION

type aob = array [0..MaxInt] of Byte;
const
  { ਧ  ࠩ 뢮 }
  ChangeWR : Boolean = false;
  Font : ^aob = nil;		{  ᨢ  }
  TCol : Byte = LightGray;	{  ᨬ }
  Bcol : Byte = Black;		{  䮭 }
var
  OldOut, OldInp : Text;
  xg, yg, x1g, y1g, x2g, y2g : Integer;
  xt,	{ ਧ⠫쭠 न  }
  yt,	{ ⨪쭠 न  }
  x1t, y1t, x2t, y2t,	{ न ⨢  }
  MaxChar, {  ⥪⮢ ப ࠭ }
  MaxLine, { ⢮ ப  ࠭ }
  xf,	{ ਭ ᨬ  ᥫ }
  yf,	{  ᨬ  ᥫ }
  Adapter : Byte; { ਧ   }

procedure WriteChar(x, y : Integer; ch : Byte);
{ 뢮 ᨬ   Ch   X,Y }
var
  k : Integer;
  b, j : Byte;
begin
  for k:=0 to Pred(yf) do
  begin
    b:=Font^[ch*yf+k];
    case Adapter of
      { 뢮  ⭮ প }
      0: for j:=0 to 7 do if b and (128 shr j)<>0 then
	PutPixel(x*xf+j,y+k,TCol) else
	  if BCol<>0 then PutPixel(x*xf+j,y+k,BCol);
      { ⭠ প EGA/VGA }
      1: asm
	{ 塞     }
		mov	ax,$a000
		mov	es,ax	{ es = $A000 }
		mov	bx,y	{ bx = y }
		add	bx,k	{ bx = y+k }
		mov	cl,4
		shl	bx,cl
		mov	dx,bx	{ dx = (y+k)*16 }
		mov	cl,2
		shl	bx,cl	{ bx = (y+k)*64 }
		add	bx,dx	{ bx = (y+k)*80 }
		add	bx,x	{ bx = (y+k)*80+x }
	{ ⠭ ०  2 }
		mov	dx,$3ce
		mov	al,5
		out	dx,al
		inc	dx
		mov	al,2
		out	dx,al
	{ 蠥  ⮫쪮  ᨬ }
		mov	dx,$3ce
		mov	al,8
		out	dx,al
		inc	dx
		mov	al,b	{ 襭  ᨬ }
		out	dx,al
	{ 뢮 ᨬ }
		mov	al,es:[bx]
		mov	al,TCol
		mov	es:[bx],al
	{ ஢塞 䮭 梥 }
		mov	dl,BCol
		cmp	dl,0
		je	@x0
	{ 塞  䮭  ᮧ 䮭 梥 }
		mov	dx,$3ce
		mov	al,8	{  ᪨ ⮢ }
		out	dx,al
		inc	dx
		mov	al,b	{   }
		not	al	{ ࠧ冷 䮭 }
		out	dx,al
	{ 뢮 䮭 }
		mov	al,es:[bx]
		mov	al,BCol
		mov	es:[bx],al { ⠭   }
	@x0:
      end
    end
  end
end;

function GraphRead(var F : TextRec) : Integer; far;
{ ⢫  ⥪  楤 Read/ReadLn }
const Csize : Word = 0;
var
  x0t : Byte;		{ 砫쭮   }
  yup, ydn : Integer;	{   }
  S : string;		{ ப  }
  C : Char;		{ । ᨬ }
  InsFlag : Boolean;	{  ० ⠢ }
  Cur,			{ ࠦ  }
  Back : Pointer;	{   }

procedure SetCursor; { ⠭   }
var FillInfo : FillSettingsType;
begin
  if Csize<>0 then
  begin
    FreeMem(Back,Csize); FreeMem(Cur,Csize)
  end;
  ydn:=yg+yf-1;
  if InsFlag then yup:=ydn-2 else yup:=yg;
  Csize:=ImageSize(xg,yup,xg+xf-1,ydn); GetMem(Back,Csize);
  GetImage(xg,yup,xg+xf-1,ydn,Back^);
  GetFillSettings(FillInfo); SetFillStyle(SolidFill,TCol);
  Bar(xg,yup,xg+xf-1,ydn);
  with FillInfo do SetFillStyle(Pattern,Color);
  GetMem(Cur,Csize); GetImage(xg,yup,xg+xf-1,ydn,Cur^);
  PutImage(xg,yup,Back^,NormalPut)
end;

procedure Cursor; {  ࠦ 饣  }
const d = 10;
var k : Integer;
begin
  GetImage(xg,yup,xg+xf-1,ydn,Back^);
  while not KeyPressed do
  begin
    PutImage(xg,yup,Cur^,NormalPut);
    for k:=1 to 10 do if not KeyPressed then Delay(d);
    PutImage(xg,yup,Back^,NormalPut);
    for k:=1 to 10 do if not KeyPressed then Delay(d)
  end
end;

procedure Home; {  -  砫 ப  }
begin
  GoToXY(x0t,WhereY)
end;

procedure Left; {  -  ᨬ  }
begin
  if WhereX>x0t then GoToXY(WhereX-1,WhereY)
end;

procedure Right; {  -  ᨬ ࠢ }
begin
  if WhereX-x0t<Length(S) then GoToXY(WhereX+1,WhereY)
end;

procedure EndKey; {  -   ப }
begin
  GoToXY(x0t+Length(S),WhereY)
end;

procedure Ins; { ४祭 ०  }
begin
  InsFlag:=not InsFlag; SetCursor
end;

procedure WriteString;
{ ⠭  ᫥ ।஢ }
var k : Byte;
begin
  for k:=1 to Length(S) do
    WriteChar(x1t+x0t+k-3,yg,Ord(S[k]));
  WriteChar(x1t+x0t+Length(S)-2,yg,32)
end;

procedure Del; {  ᨬ  ஬ }
var N : Byte;
begin
  N:=WhereX-x0t;
  if N<Length(S) then
  begin
    Delete(S,N+1,1); WriteString
  end
end;

procedure BackSpace; {  ᨬ ᫥   }
var N : Byte;
begin
  N:=WhereX-x0t;
  if N>=1 then
  begin
    Delete(S,N,1); WriteString; GoToXY(WhereX-1,WhereY)
  end
end;

procedure AnyChar;
var N : Byte;
begin
  N:=WhereX-x0t;
  if N=Length(S) then if x1t+x0t+Length(S)<=x2t then S:=S+C
    else else if InsFlag and (x1t+x0t+Length(S)<=x2t) then
      Insert(C,S,N+1) else S[N+1]:=C;
  WriteString; GoToXY(WhereX+1,WhereY)
end;

procedure Enter; { 蠥    Enter }
var k : Byte;
begin
  with F do
  begin
    for k:=1 to Length(S) do BufPtr^[BufEnd+k-1]:=S[k];
    BufEnd:=Length(S);
    if BufEnd=0 then
    begin
      BufEnd:=1; BufPtr^[0]:=' '
    end
  end;
  GoToXY(1,WhereY+1)
end;

procedure Esc; { 室   Esc }
begin
  with F do
  begin
    BufEnd:=1; BufPtr^[0]:=' '; EscFlag:=true
  end
end;

begin { GraphRead }
  with F do if (Mode=fmInput) and (BufEnd=0) then
  begin
    x0t:=WhereX; S:=''; InsFlag:=true;
    EscFlag:=false; SetCursor;
    repeat
      Cursor; C:=ReadKey;
      case C of
	#0: case Ord(ReadKey) of
	  71: Home; 75: Left; 77: Right;
	  79: EndKey; 82: Ins; 83: Del
	  else C:=#0
	end;
	#8: BackSpace; #13: Enter; #27: Esc
	else AnyChar
      end
    until (C=#13) or (C=#27);
    FreeMem(Back,Csize); FreeMem(Cur,Csize); Csize:=0
  end;
  GraphRead:=0
end { GraphRead };

function GraphWrite(var F : TextRec) : Integer; far;
{ ⢫ 뢮 ⥪ }
var
  reg : Registers;
  k, Drv, Mode : Integer;
begin
  if Font=nil then Exit;
  DetectGraph(Drv,Mode);
  if AppHandle and (Drv in [3..5,9]) then
    Adapter:=1		{ EGA, VGA }
      else Adapter:=0;  { 㣨 ⨯   AppHandle }
  with F do if (Mode=fmOutput) and (BufPos>0) then
  begin
    for k:=0 to BufPos-1 do case BufPtr^[k] of
      { ࠡ뢠 ᯥᨬ }
      #7: with reg do
      begin
	ah:=$1e; al:=7; Intr($10,reg)
      end;
      #8: if k>BufEnd then
      begin
	WriteChar(xt-2,yg,32); GoToXY(WhereX-1,WhereY)
      end;
      #10: if yt+1 in [y1t..y2t] then
				GoToXY(WhereX,WhereY+1);
      #13: GoToXY(1,WhereY)
      else begin
	WriteChar(xt-1,yg,Ord(BufPtr^[k]));
	if xt+1 in [x1t..x2t] then GoToXY(WhereX+1,WhereY)
	  else if yt+1 in [y1t..y2t] then
	    GoToXY(1,WhereY+1)
      end
    end;
    BufPos:=0
  end;
  GraphWrite:=0
end;

function Zero(var F : TextRec) : Integer; far;
{ 誠  㭪権 Open/Close }
begin
  Zero:=0
end;

function Flush(var F : TextRec) : Integer; far;
{    }
begin
  with F do
  begin
    BufPos:=0; BufEnd:=0
  end;
  Flush:=0
end;

procedure ClrScr;
var FillInfo : FillSettingsType;
begin
  if Font<>nil then
  begin
    GetFillSettings(FillInfo); SetFillStyle(SolidFill,BCol);
    Bar(x1g,y1g,x2g,y2g);
    with FillInfo do SetFillStyle(Pattern,Color);
    GoToXY(1,1)
  end
end;

procedure Colors(Text, Back : Byte);
begin
  TextColor(Text); TextBackGround(Back)
end;

function GetMaxChar : Byte;
begin
  GetMaxChar:=MaxChar
end;

function GetMaxLine : Byte;
begin
  GetMaxLine:=MaxLine
end;

procedure GetWindGraphCoo(var x1, y1, x2, y2 : Integer);
begin
  x1:=x1g; y1:=y1g; x2:=x2g; y2:=y2g
end;

procedure GoToXY(x, y : Byte);
begin
  if (Font<>nil) and (x in [1..MaxChar]) and
    (y in [1..MaxLine]) and (x<=x2t-x1t+1) and
      (y<=y2t-y1t+1) then
  begin
    xt:=x+x1t-1; yt:=y+y1t-1;
    xg:=GraphCooX(xt); yg:=GraphCooY(yt)
  end
end;

function GraphCooX(x : Byte) : Integer;
begin
  if Font<>nil then GraphCooX:=Pred(x)*xf else GraphCooX:=-1
end;

function GraphCooY(y : Byte) : Integer;
begin
  if Font<>nil then GraphCooY:=Pred(y)*yf else GraphCooY:=-1
end;

procedure GraphWriteOn;
begin
  if not ChangeWR then
  begin
    Move(Output,OldOut,SizeOf(Output));
    with TextRec(Output) do
    begin
      OpenFunc:=@Zero; CloseFunc:=@Zero;
      FlushFunc:=@GraphWrite; InOutFunc:=@GraphWrite
    end;
    Move(Input,OldInp,SizeOf(Input));
    with TextRec(Input) do
    begin
      OpenFunc:=@Zero; CloseFunc:=@Zero;
      FlushFunc:=@Flush; InOutFunc:=@GraphRead
    end;
    ChangeWR:=true
  end
end;

procedure GraphWriteOff;
begin
  if ChangeWR then
  begin
    Move(OldOut,Output,SizeOf(Output));
    Move(OldInp,Input,SizeOf(Input)); ChangeWR:=false
  end
end;

procedure SetFont(Fnt : Pointer; x, y : Byte);
begin
  Font:=Fnt; MaxChar:=Succ(GetMaxX) div x;
  MaxLine:=Succ(GetMaxY) div y; xf:=x; yf:=y;
  Window(1,1,MaxChar,MaxLine)
end;

procedure Scrolling(N : Integer);
var
  k : Byte;
  p : Pointer;
  x, y, LineSize : Word;
  FillInfo : FillSettingsType;
begin
  GetFillSettings(FillInfo); SetFillStyle(SolidFill,BCol);
  LineSize:=ImageSize(x1g,y1g,x2g,y1g+yf);
  if Abs(N)>=y2t-y1t+1 then {   }
    Bar(x1g,y1g,x2g,y2g) else if N>0 then
  begin
    {   }
    GetMem(p,LineSize);
    for k:=0 to y2t-y1t-N do
    begin
      GetImage(x1g,y1g+(N+k)*yf,x2g,y1g+(N+k+1)*yf,p^);
      PutImage(x1g,y1g+k*yf,p^,NormalPut)
    end;
    FreeMem(p,LineSize); Bar(x1g,y2g-N*yf,x2g,y2g)
  end
  else if N<0 then begin
    {   }
    GetMem(p,LineSize); N:=Abs(N);
    for k:=y2t-y1t-N downto 1 do
    begin
      GetImage(x1g,y1g+(k-1)*yf,x2g,y1g+k*yf,p^);
      PutImage(x1g,y2g-(y2t-y1t-N-k+1)*yf,p^,NormalPut)
    end;
    FreeMem(p,LineSize); Bar(x1g,y1g,x2g,y1g+N*yf)
  end;
  with FillInfo do SetFillStyle(Pattern,Color)
end;

procedure TextBackGround(Color : Byte);
begin
  BCol:=Color
end;

procedure TextColor(Color : Byte);
begin
  TCol:=Color
end;

function TextCooX(x : Integer) : Byte;
begin
  if (Font<>nil) and (x in [0..GetMaxX]) then
    TextCooX:=Round(x/MaxChar)+1 else TextCooX:=0
end;

function TextCooY(y : Integer) : Byte;
begin
  if (Font<>nil) and (y in [0..GetMaxY]) then
    TextCooY:=Round(y/MaxLine)+1 else TextCooY:=0
end;

function WhereX : Byte;
begin
  if Font<>nil then WhereX:=xt-x1t+1 else WhereX:=0
end;

function WhereY : Byte;
begin
  if Font<>nil then WhereY:=yt-y1t+1 else WhereY:=0
end;

procedure Window(x1, y1, x2, y2 : Byte);
begin
  if (Font<>nil) and (x1 in [1..MaxChar]) and
    (y1 in [1..MaxLine]) and (x2 in [1..MaxChar]) and
      (y2 in [1..MaxLine]) and (x2>=x1) and (y2>=y1) then
  begin
    xt:=x1; yt:=y1; xg:=xf*Pred(xt); yg:=yf*Pred(yt);
    x1t:=x1; y1t:=y1; x2t:=x2; y2t:=y2; x1g:=xf*Pred(x1t);
    y1g:=yf*Pred(y1t); x2g:=xf*x2t; y2g:=yf*y2t
  end
end;

procedure SetWindow(x1, y1, x2, y2, Border : Byte;
	Header : string; Clip, Build, Play : Boolean);
const
  N = 20;
  Pause = 5;
  TonBeg = 400;
  TonEnd = 800;
var
  dt : Integer;
  k, x, xx1, yy1, xx2, yy2, dx, dy : Byte;
begin
  if (Font<>nil) and (x1 in [1..MaxChar]) and
    (y1 in [1..MaxLine]) and (x2 in [1..MaxChar]) and
      (y2 in [1..MaxLine]) and (x2>=x1) and (y2>=y1) then
  begin
    if Build and ((x2-x1>=4) or (y2-y1>=4)) then
    begin
      x:=(x2-x1) div 2;
      if x>1 then
      begin
	xx1:=x1+x-1; xx2:=x1+x+1
      end
      else begin
	xx1:=x1; xx2:=x2
      end;
      x:=(y2-y1) div 2;
      if x>1 then
      begin
	yy1:=y1+x-1; yy2:=y1+x+1
      end
      else begin
	yy1:=y1; yy2:=y2
      end;
      dx:=(x2-x1) div N; if dx=0 then dx:=1;
      dy:=(y2-y1) div N; if dy=0 then dy:=1;
      dt:=(TonEnd-TonBeg) div N;
      for k:=0 to N-1 do
      begin
	if Play then Sound(TonBeg+k*dt);
	Window(xx1,yy1,xx2,yy2); ClrScr;
	if xx1>x1 then Dec(xx1,dx);
	if xx2<x2 then Inc(xx2,dx);
	if yy1>y1 then Dec(yy1,dy);
	if yy2<y2 then Inc(yy2,dy);
	Delay(Pause)
      end;
      if Play then NoSound
    end;
    Window(x1,y1,x2,y2); ClrScr;
    if Border in [0..2] then
    begin
      Write(BorderChar[Border,1]);
      for k:=2 to x2-x1 do Write(BorderChar[Border,2]);
      Write(BorderChar[Border,3]);
      for k:=2 to y2-y1 do
      begin
	GoToXY(1,k); Write(BorderChar[Border,4]);
	GoToXY(x2-x1+1,k); Write(BorderChar[Border,4])
      end;
      GoToXY(1,y2-y1+1); Write(BorderChar[Border,5]);
      for k:=2 to x2-x1 do Write(BorderChar[Border,2]);
      Write(BorderChar[Border,6])
    end;
    if Length(Header)>0 then
    begin
      if Length(Header)>x2-x1-2 then Header[0]:=Chr(x2-x1-2);
      GoToXY((x2-x1-Length(Header)) div 2+2,1); Write(Header)
    end;
    if Clip then Window(x1+1,y1+1,x2-1,y2-1)
  end
end;

{ ----      ---- }

type
  PFontDesc = ^TFontDesc;
  TFontDesc = record		{ ⥫ : }
    NextFont : PFontDesc;	{ 뫪  ᫥騩 }
    NFont : Integer;		{   }
    Name : record case Byte of
      0: (FName : string);	{  䠩 }
      1: (Flag : Byte;		{  ଠ }
      Addrs : record		{  }
	sa, oa : Word
      end)
    end;
    FirstChr,			{  ᨬ }
    LastChar : Byte;		{ ᫥ ᨬ }
    Height,			{    }
    Bottom : ShortInt;		{    }
    Offs,			{ 饭 }
    Leng : array [0..255] of Word  {  }
  end;
  TFontPara = record		{  ࠬ஢ : }
    ParPrefix : Char;		{  '+' }
    CharsCount : Word;		{ ᫮ ᨬ   }
    Reserv1,			{  ᯮ }
    FirstChar : Byte;		{  ࢮ ᨬ }
    DataOffset : Word;		{ 饭  
				   ࢮ ᨬ }
    FillFlag,			{   }
    UpperMargin,		{  ᨬ }
    Reserv2 : Byte;		{  ᯮ }
    LowerMargin : ShortInt;	{  ஬ }
    Reserv3 : array [1..5] of Byte	{  ᯮ }
  end;
  THead = array [1..4] of Char;
const
  FontList : PFontDesc = nil;	{ ᮪ ⮢ }
  FontNumb : Integer = 0;	{ ⢮ ⮢ }
  Head0 : THead = 'PK'#8#8;
var
  FDesc : TFontDesc;
  F : file;
  Buf : array [1..128] of Byte; {  }
  FPar : TFontPara;		{ ࠬ  }
  Head : THead absolute Buf;

function RegisterCHRFile(S : string) : Integer;
var
  Err : Boolean;
  k : Integer;
  ParOffs : Word;
  p, pd : PFontDesc;

function ReadFile(var Dest; Size : Word) : Boolean;
{ ⠥ Size   䠩 F  ६ Dest }
begin
  BlockRead(F,Dest,Size,k); ReadFile:=k=Size
end;

begin { RegisterCHRFile }
  { ஢塞  ४㥬  }
  if Pos('.',S)=0 then S:=S+'.chr';
  { ஢塞  ᯨ, ⮡
    ᪫  ॣ }
  if FontNumb<>0 then
  begin
    FDesc:=FontList^;
    with FDesc do while (NextFont<>nil) and
      (S<>Name.FName) do FDesc:=NextFont^;
    if S=FDesc.Name.FName then
    begin
      {   ᯨ᪥ -   }
      RegisterCHRFile:=FDesc.NFont; Exit
    end
  end;
  { 뢠 䠩 }
  RegisterCHRFile:=-1; Assign(F,S);
  Reset(F,1); if IOresult<>0 then Exit;
  { ⠥  }
  if not ReadFile(Buf,128) then Exit;
  {  ଠ 䠩 }
  RegisterCHRFile:=-2; if Head<>Head0 then Exit;
  { 饬  ⥪ }
  repeat
    k:=1; while (k<=128) and (Buf[k]<>$1a) do Inc(k);
    if k=129 then if not ReadFile(Buf,128) then Exit
  until Buf[k]=$1a;
  { 樮㥬 䠩   ࠬ஢ }
  ParOffs:=Buf[k+1]+Buf[k+2] shl 8; Seek(F,ParOffs);
  { ⠥ ࠬ }
  if not ReadFile(FPar,16) or
    (FPar.ParPrefix<>'+') then Exit;
  { ࢨ㥬   ⥫ }
  RegisterCHRFile:=-3;
  if MaxAvail<SizeOf(TFontDesc) then Exit; {   }
  New(pd);
  { ନ㥬  ਯ }
  with pd^,FPar do
  begin
    NextFont:=nil; NFont:=FontNumb+1; Name.FName:=S;
    FirstChr:=FirstChar; LastChar:=FirstChar+CharsCount-1;
    Height:=UpperMargin; Bottom:=LowerMargin;
    { ⠥ ⠡ ᬥ饭 }
    RegisterCHRFile:=-1;
    Seek(F,ParOffs+DataOffset-3*CharsCount);
    if not ReadFile(Offs[FirstChar],2*CharsCount) then
    begin
      Dispose(pd); Exit
    end;
    { ࠨ ᬥ饭 }
    for k:=FirstChar to LastChar do
      Offs[k]:=Offs[k]+ParOffs+DataOffset;
    { ନ㥬 ⠡  }
    for k:=FirstChar to LastChar-1 do
      Leng[k]:=Offs[k+1]-Offs[k];
    Leng[LastChar]:=FileSize(F)-Offs[LastChar-1]-ParOffs
  end;
  { ନ㥬 ᯨ᮪ ⥫ }
  if FontNumb=0 then FontList:=pd { ᮪   } else
  { 饬  ᯨ᪠ }
  begin
    { 砫 ᯨ᪠ }
    p:=FontList;
    { Next=nil -  }
    while p^.NextFont<>nil do p:=p^.NextFont;
    p^.NextFont:=pd
  end;
  Inc(FontNumb); RegisterCHRFile:=FontNumb
end { RegisterCHRFile };

function RegisterCHRFont(Font : Pointer) : Integer;
type TByte = array [0..65534] of Byte;
var
  ph : ^THead;
  pp : ^TFontPara;
  pb : ^TByte absolute ph;
  p, pd : PFontDesc;
  k : Integer;
  ParOffset, FileSize : Word;
begin
  { ஢塞 砫  }
  ph:=Font; RegisterCHRFont:=-2;
  {   'PK'#8#8 }
  if ph^<>Head0 then Exit;
  { 饬 CopyrightEnd }
  k:=4; while (pb^[k]<>$1a) and (k<256) do Inc(k);
  {  諨 ନ  256  }
  if pb^[k]<>$1a then Exit;
  { ஢塞  ࠬ஢ }
  ParOffset:=pb^[k+1]+pb^[k+2] shl 8;
  FileSize:=pb^[k+7]+pb^[k+8] shl 8;
  pp:=Addr(pb^[ParOffset]);
  {  䨪 ࠬ஢ }
  if pp^.ParPrefix<>'+' then Exit;
  { ࢨ㥬   ⥫ }
  RegisterCHRFont:=-3;
  if MaxAvail<SizeOf(TFontDesc) then Exit; {   }
  New(pd);
  { ନ㥬  ਯ }
  with pd^,pp^ do
  begin
    NextFont:=nil; NFont:=FontNumb+1;
    Name.Flag:=0; {  -   }
    k:=ParOffset+DataOffset;
    {   }
    Name.Addrs.sa:=Seg(pb^[k]); Name.Addrs.oa:=Ofs(pb^[k]);
    FirstChr:=FirstChar; LastChar:=FirstChar+CharsCount-1;
    Height:=UpperMargin; Bottom:=LowerMargin;
    { ७ᨬ ⠡ ᬥ饭 }
    k:=ParOffset+DataOffset-3*CharsCount;
    Move(pb^[k],Offs[FirstChar],2*CharsCount);
    { ନ㥬 ⠡  }
    for k:=FirstChar to LastChar-1 do
      Leng[k]:=Offs[k+1]-Offs[k];
    Leng[LastChar]:=FileSize-Offs[LastChar-1]
  end;
  { ନ㥬 ᯨ᮪ ⥫ }
  if FontNumb=0 then FontList:=pd { ᮪   } else
  { 饬  ᯨ᪠ }
  begin
    { 砫 ᯨ᪠ }
    p:=FontList;
    { Next=nil -  }
    while p^.NextFont<>nil do p:=p^.NextFont;
    p^.NextFont:=pd
  end;
  Inc(FontNumb); RegisterCHRFont:=FontNumb
end;

procedure OutString(S : string; Font : Integer;
	Angle : Integer; MX, MY : Real);
var
  Ang : Real;
  x0, y0 : Integer; { 砫 । ᨬ }

procedure OutChar(var V);
{ 믮   V }
var
  k, op : Word;
  Vec : array [1..MaxInt] of Word absolute V;

procedure Coo(x, y : Integer; var xx, yy : Integer);
{ ⢫  न x, y  㣮
  Angle  頥  न xx, yy }
var r, a : Real;
begin
  { ॢ   न }
  r:=Sqrt(1.0*x*x+1.0*y*y);
  if x=0 then if y<0 then a:=-Pi/2 else a:=Pi/2
    else a:=ArcTan(y/x);
  {  न }
  a:=a+Ang;
  { 塞  न }
  yy:=Round(r*Sin(a)); xx:=Round(r*Cos(a))
end;

var x, y, x1, y1, xx, yy : Integer;
begin { OutChar }
  k:=1; x:=x0; y:=y0;
  repeat
    op:=Vec[k] and $8080; xx:=Vec[k] and $7f;
    yy:=(Vec[k] shr 8) and $7f;
    if yy>63 then yy:=yy-128;
    { 뢠 ⠡ 樥 }
    xx:=Round(xx*MX); yy:=Round(yy*MY);
    { 稢  㣮 Angle }
    Coo(xx,yy,x1,y1); x1:=x0+x1; y1:=y0-y1;
    { 稢  }
    if op=$8080 then Line(x,y,x1,y1);
    { 室    }
    if op<>0 then
    begin
      x:=x1; y:=y1
    end;
    { ஢塞   }
    if op=0 then
    begin
      { ⮢ 뢮 ᫥饣 } x0:=x; y0:=y
    end
    else Inc(k)
  until op=0
end { OutChar };

var
  F : file;
  c : Byte;
  k, j : Word;
  p : PFontDesc;
  pb : Pointer;
  Buf : array [1..1000] of Word;
begin { OutString }
  { 饬 ॣ  }
  if (FontNumb=0) or (Font>FontNumb) or (S='')
    {    ,  ப 
         } then Exit;
  p:=FontList;
  { ॢ 㣮  ࠤ } Ang:=Angle*Pi/180;
  for k:=1 to Font-1 do p:=p^.NextFont;
  with p^ do
  begin
    if Name.FName<>'' then
    begin
      Assign(F,Name.FName); Reset(F,1);
      if IOresult<>0 then Exit
    end;
    { 騥 न } x0:=GetX; y0:=GetY;
    for k:=1 to Length(S) do
    begin
      c:=Ord(S[k]);
      if c in [FirstChr..LastChar] then
	if Name.FName<>'' then
      begin
	{ ६   䠩 }
	Seek(F,Offs[c]); BlockRead(F,Buf,Leng[c],j);
	if (IOresult=0) and (Leng[c]=j) then OutChar(Buf)
      end
      else with Name.Addrs do
      begin
	{  㦥   }
	pb:=Ptr(sa,oa+Offs[c]); OutChar(pb^)
      end
    end;
    MoveTo(x0,y0); if Name.Fname<>'' then Close(F)
  end
end { OutString };

end { F_GrText }.