program Mouse_T;
{ ணࠬ,    F_Mouse }
uses Crt, Graph, F_Mouse, F_GrText, F_Text;
const
  t1 = '  ⥩  F_Mouse ';
  t2 = '  ﭨ : ';
  t3 : array [1..4] of string[22] =
    ('न: X=   Y=   ', '   :',
     'ࠢ  :', '। :');
  NItem = 3;
  t4 : array [1..NItem] of string[24] =
    ('  㪠⥫ (F1)',
     '    ० (F2)', '  ࠡ (ESC)');
type
  ItemT = array [1..NItem] of MouseItemType;
  GoToXYType = procedure(x, y : Byte);
  ColorsType = procedure(Text, Back : Byte);
  SetWindowType = procedure(x1, y1, x2, y2, Border : Byte;
	Header : string; Clip, Build, Play : Boolean);
  ChangeCursorType = procedure;
const
  Items : ItemT = (
    (x1:9; y1:4; x2:35; y2:6; Butt:LeftButton; Key:59 shl 8),
    (x1:44; y1:4; x2:68; y2:6; Butt:LeftButton; Key:60 shl 8),
    (x1:27; y1:18; x2:52; y2:20; Butt:LeftButton; Key:27));
  Text : Boolean = true;
var
  N, k, b, x, y, bb, xx, yy : Integer;
  Font : Pointer;
  FontSize : Word;
  GoToXY : GoToXYType;
  Colors : ColorsType;
  SetWindow : SetWindowType;
  ChangeCursor : ChangeCursorType;

procedure SetScreen;
{  ࠭  ⥪⮢  ᪮ ० }
begin
  {  ᭮  }
  Colors(Black,LightGray); SetWindow(1,1,80,25,DoubleBorder,
    t1,true,false,false); Colors(Black,Green);
  {   롮 }
  for k:=1 to NItem do with Items[k] do
  begin
    SetWindow(x1,y1,x2,y2,SingleBorder,'',true,false,false);
    Write(t4[k])
  end;
  {    }
  N:=(30-Length(t2)) div 2; Colors(White,Red);
  SetWindow(24,9,55,16,DoubleBorder,t2,true,false,false);
  for k:=1 to 4 do
  begin
    GoToXY(N-3,k+1); Write(t3[k])
  end
end;

procedure ChangeTextCursor; far;
{    ⥪⮢ ० }
const t = ' 롥 ᨬ  㪠⥫  ';
var
  k : Byte;
  N, x, y : Integer;
begin
  {   롮 }
  HideMouse; PutWindow(8,7,73,12,White,Blue,
    DoubleBorder,1,t,true,false,false);
  { 뢮    ᨬ, ஬ Bel, BS, LF  CR }
  for k:=1 to 255 do if k in [7,8,10,13] then
    Write(' ') else Write(Chr(k));
  { ନ㥬 । ६饭 㪠⥫ }
  MouseWindow(MouseGraphCooX(9),MouseGraphCooY(8),
    MouseGraphCooX(72),MouseGraphCooY(11));
  {   ᪠   }
  repeat
    GetMouseState(b,x,y)
  until b and LeftButton=0;
  ShowMouse;
  {      }
  repeat
    GetMouseState(b,x,y)
  until b and LeftButton<>0;
  HideMouse;
  { ।塞 ࠭ ᨬ }
  x:=MouseTextCooX(x)-8; y:=MouseTextCooY(y)-7;
  x:=(y-1)*64+x; if x>255 then x:=1;
  { 塞   }
  MouseTextCursor($ff00,$7f00+x);
  { ⠭ ࠭ }
  GetWindow(1); MouseScreen; ShowMouse
end;

{  ।  ࠡ稪 ᮡ⨩  ,
  ᯮ㥬  ० 롮 ᪮ 㪠⥫ }
const
  dx = 40;	{  ᬥ饭 ࠦ }
  NCur = 4;	{ ⢮ ࠦ }
var
  PP : Pointer;		{ ࠦ 㪠⥫ }
  SizePP : Word;	{  ࠧ   }
  kk,			{  ࠭ ࠦ }
  x0,			{  ࠭ ࠦ }
  y0, y1 : Integer;	{ ⨪ ࠭ }

procedure MouseHandler(Mask, Buttons,
	x, y, Ddx, dy : Integer); far;
{ ᫥ ६饭    ࠦ,
   ஥ 㪠뢠    㪠⥫  }
var k : Integer; { 饥 ࠦ }
begin
  k:=(x-x0) div dx; if k<1 then k:=1;
  if k>NCur then k:=NCur;
  if k=kk then Exit; { 饥 ࠦ   }
  { ᨬ ஥  뤥塞  ࠦ }
  PutImage(x0+(2*kk-1)*dx div 2,y0,PP^,NormalPut);
  GetImage(x0+(2*k-1)*dx div 2,y0,x0+(2*k+1)*dx div 2,y1,PP^);
  PutImage(x0+(2*k-1)*dx div 2,y0,PP^,NotPut); kk:=k
end;

procedure ChangeGraphCursor; far;
{    ᪮ ० }
const t = ' 롥 㪠⥫: ';
var
  x, y, x1 : Integer;
  p : Pointer;
  Size, b : Word;
  Proc : MouseHandlerType;
  Cur : array [1..NCur, 0..1, 0..15] of Word;

procedure PutCur(N : Byte);
{  ࠦ   孥
  㣫 ࠭  ନ ᪨ 㪠⥫ }
var
  b : Word;
  x, y : Byte;
begin
  for y:=0 to 15 do
  begin
    b:=0;
    for x:=0 to 15 do if GetPixel(x,y)<>GetBkColor then
      b:=b or ($8000 shr x);
    Cur[N,1,y]:=b; Cur[N,0,y]:=not b
  end;
  ClearViewPort
end;

begin
  { ⮢  16x16   孥 㣫 ࠭ }
  Size:=ImageSize(0,0,15,15); GetMem(p,Size);
  GetImage(0,0,15,15,p^); SetViewPort(0,0,15,15,ClipOn);
  ClearViewPort;
  { ⮢ ᪨ 㪠⥫ }
  HideMouse;
  { 砥 ⠭⭮ ࠦ }
  InitMouse; ShowMouse; SetMouseItem(NItem,Items);
  MouseGoToXY(0,0); PutCur(1);
  { 㦮 }
  HideMouse; Circle(8,8,4); PutCur(2);
  { ४⨥ }
  Line(0,8,15,8); Line(8,0,8,15); PutCur(3);
  { ⨪ }
  Rectangle(0,0,15,15); PutPixel(7,7,15); PutCur(4);
  SetViewPort(0,0,GetMaxX,GetMaxY,ClipOn);
  { ⮢    㪠⥫ }
  PutImage(0,0,p^,NormalPut); FreeMem(p,Size);
  x0:=GraphCooX(9); y0:=GraphCooY(7);
  x1:=GraphCooX(36); y1:=GraphCooY(10);
  Size:=ImageSize(x0,y0,x1,y1); GetMem(p,Size);
  GetImage(x0,y0,x1,y1,p^); Colors(White,Blue); y1:=y0+16;
  SetWindow(9,7,35,9,DoubleBorder,t,true,false,false);
  { 뢮 ࠦ 㪠⥫ }
  for kk:=1 to NCur do for y:=0 to 15 do
  begin
    x1:=x0+kk*dx; b:=Cur[kk,1,y];
    for x:=0 to 15 do if b and ($8000 shr x)<>0 then
      PutPixel(x1+x,y1+y,White)
  end;
  { ⠭ । ६饭 㪠⥫ }
  y0:=y0+16; y1:=y1+16; MouseWindow(x0,y0,x1+dx,y1);
  { 뤥塞 ࢮ ࠦ }
  SizePP:=ImageSize(x0+dx div 2,y0,x0+3*dx div 2,y1);
  GetMem(PP,SizePP);
  GetImage(x0+dx div 2,y0,x0+3*dx div 2,y1,PP^);
  PutImage(x0+dx div 2,y0,PP^,NotPut); kk:=1;
  { ⠭ ᢮ ࠡ稪 ᮡ⨩ }
  SetMouseHandler(1,MouseHandler);
  {      }
  repeat
    GetMouseState(k,x,y)
  until k and LeftButton<>0;
  { 塞 ࠡ稪 ᮡ⨩ }
  ClearMouseHandler; FreeMem(PP,SizePP);
  { ନ㥬  㪠⥫ }
  kk:=(x-x0) div dx; if kk>NCur then kk:=NCur;
  if kk<1 then kk:=1;
  MouseGraphCursor(Cur[kk,0,0],0,0);
  { ⠭ ࠭ }
  PutImage(x0,y0-16,p^,NormalPut); FreeMem(p,Size);
  MouseWindow(0,0,GetMaxX,GetMaxY);
  F_GrText.Window(25,10,54,15); Colors(White,Red); ShowMouse
end;

procedure SetTextScreen; {  ⥪⮢ ࠭ }
begin
  if not Text then
  begin
    FreeMem(Font,FontSize); { 塞  }
    GraphWriteOff; { ⠭ /뢮 }
    CloseGraph; Text:=true
  end;
  { 뢠 㦭  ⥪⮢ ० 楤 }
  GoToXY:=F_Text.GoToXY; SetWindow:=F_Text.SetWindow;
  Colors:=F_Text.Colors; ChangeCursor:=ChangeTextCursor;
  { ⠭ ⠭ 樥  }
  TextRatioY:=8;
  {  ⥪⮢ ࠭ }
  SetScreen
end;

procedure SetGraphScreen; {  ᪨ ࠭ }
var
  d, r : Integer;
  h : Byte;
  Name : string;
  F : file;
begin
  if Text then
  begin
    d:=Detect; InitGraph(d,r,'');
    if GraphResult<>GrOk then Exit;
    { 롨ࠥ   ᨬ  ࠧ襭 ࠭ }
    case GetMaxY of
      349: h:=14; 479: h:=19 else h:=8
    end;
    { 㦠   䠩 8xh.fnt }
    Str(h,Name); Name:='8x'+Name+'.fnt'; Assign(F,Name);
    Reset(F,1); if IOresult<>0 then Exit;
    FontSize:=FileSize(F); GetMem(Font,FontSize);
    BlockRead(F,Font^,FontSize,r); Close(F);
    if r<>FontSize then
    begin
      FreeMem(Font,FontSize); Exit
    end;
    { 㥬   ७砥 /뢮 }
    SetFont(Font,8,h); GraphWriteOn; Text:=false;
    { 뢠 㦭  ᪮ ० 楤 }
    GoToXY:=F_GrText.GoToXY; SetWindow:=F_GrText.SetWindow;
    Colors:=F_GrText.Colors; ChangeCursor:=ChangeGraphCursor;
    {  樥  ⨪쭮
       㪠⥫   ⥪⮢ ࠧ:
       ࠢ   }
    TextRatioY:=h;
    {  ᪨ ࠭ }
    SetScreen
  end
end;

begin
  if not InitMouse then Halt;
  CursorOff;
  { ନ㥬 ⥪⮢ ࠭ }
  SetTextScreen; ShowMouse;
  { 뢠  롮 }
  SetMouseItem(NItem,Items);
  {  砫쭮 ﭨ  }
  GetMouseState(b,x,y);
  { "᪮" 横 }
  while true do
  begin
    { ஢塞 롮 ⮢ }
    if KeyOrMousePressed then case ReadKeyOrMouse of
      #27: begin
	HideMouse; CloseGraph; F_Text.Colors(LightGray,Black);
	Window(1,1,80,25); CursorOn; ClrScr; Halt
      end;
      #0: case ReadKeyOrMouse of
	#59: ChangeCursor;
	#60: begin
	  HideMouse;
	  if Text then SetGraphScreen else SetTextScreen;
	  { 樨㥬  ᫥ ᬥ ०! }
	  if InitMouse then ShowMouse;
	  {  㪠뢠  롮,
	    ..  뢠  樠樨  }
	  SetMouseItem(NItem,Items)
	end
      end
    end;
    { 砥 ⥪饥 ﭨ  }
    GetMouseState(bb,xx,yy);
    if (bb<>b) or (xx<>x) or (yy<>y) then
    begin
      { ﭨ  - ᮮ }
      b:=bb; x:=xx; y:=yy;
      GoToXY(N+11,2); Write(MouseTextCooX(x):2);
      GoToXY(N+16,2); Write(MouseTextCooY(y):2);
      GoToXY(N+13,3); if b and LeftButton<>0 then
	Write('  ') else Write('饭');
      GoToXY(N+13,4); if b and RightButton<>0 then
	Write('  ') else Write('饭');
      GoToXY(N+13,5); if NumButton=3 then
	if b and CenterButton<>0 then
	  Write('  ') else Write('饭')
    end
  end
end { Mouse_T }.